
;---------------------------------------------
;LOOKUP TABLES
;---------------------------------------------
INVALIDPOS:	DB $24,$25,$34,$35,$64,$65,$74,$75		;THIS LOOKUP TABLE CONTAINS INVALID SPOTS TO MOVE TO IN THE PLAYFIELD, THE TWO OBSTACLES(CASTLES) IN THE MIDDLE

palette:											;THIS PART INCLUDES THE DEFINITION OF THE 16 COLORS USED IN THE GAME, EXPORTED FROM AKUSPRITE EDITOR
    dw $0000 ;0  -RGB	;BLACK
    dw $0800 ;1  -RGB	;DARK RED
    dw $0080 ;2  -RGB	;DARK GREEN
    dw $0880 ;3  -RGB	;DARK YELLOW
    ;dw $0008 ;4  -RGB	;DARK BLUE
	dw $000E ;4  -RGB	;DARK BLUE					;I MADE BOTH THE BLUE COLORS LIGHTER, THEY WERE TOO DARK.
    dw $0808 ;5  -RGB	;DARK MAGENTA	
    dw $0088 ;6  -RGB	;DARK CYAN
    dw $0CCC ;7  -RGB	;LIGHT GRAY
    dw $0888 ;8  -RGB	;DARK GRAY
    dw $0F00 ;9  -RGB	;LIGHT RED
    dw $00F0 ;10  -RGB	;LIGHT GREEN
    dw $0FF0 ;11  -RGB	;LIGHT YELLOW
    ;dw $000F ;12  -RGB	;LIGHT BLUE
	dw $022F ;12  -RGB	;LIGHT BLUE
    dw $0F0F ;13  -RGB	;LIGHT MAGENTA
    dw $00FF ;14  -RGB	;LIGHT CYAN
    dw $0FFF ;15  -RGB	;WHITE

;---------------------------------------------
;INCLUDE EXTERNAL FILES
;---------------------------------------------
	include "\Sources\x16-Strategy\Functions.asm"
	include "\Sources\x16-Strategy\Phase0.asm"
	include "\Sources\x16-Strategy\Phase1.asm"
	include "\Sources\x16-Strategy\Phase2.asm"
	include "\Sources\x16-Strategy\Phase3.asm"
	include "\Sources\x16-Strategy\Phase4.asm"
	
	include "\Sources\x16-Strategy\Includes\BasicFunctions.asm"	
	
	BitmapFont:
	incbin "\Sources\x16-Strategy\Includes\Font96.FNT"
	
;---------------------------------------------	
;THE TEXT USED IN THE GAME
;---------------------------------------------
SEEDASK		BYTE	$F9," WHAT IS TODAY'S DATE?: ",255
ASKSIDE		BYTE	$F9," WHICH TEAM WOULD YOU LIKE TO PLAY AS",$FA," RED OR BLUE? (R/B): ",255
PLACE1		BYTE	$E1,$DC,"      PIECES LEFT",$F9," SELECT A LOCATION",$FA," TO PLACE A PIECE DOWN",$FB," USE A HOTKEY TO PLACE",$FC," OR HIT RETURN",255
PLACE2		BYTE	$F9," WHICH PIECE TO PLACE?",$FA," B=BOMB F=FLAG 0=SPY 1=SCOUT 2=MINER",$FB," 3=CPL 4=LTN 5=CPT 6=MAJ 7=COL 8=GEN",$FC," 9=MARSHALL : ",255
PLACEERR	BYTE	$F9," SORRY!",$FA," YOU DON'T HAVE ANY OF THAT",$FB," PIECE LEFT! TRY AGAIN..",$FC," PRESS A KEY",255
PLACEERR2	BYTE	$F9," SORRY!",$FA," THAT SPOT ISN'T FREE!",$FB," ",$FC," PRESS A KEY",255
PLACEERR3 	BYTE	$F9," SORRY!",$FA," INVALID SELECTION!",$FB," ",$FC," PRESS A KEY",255
MOVE		BYTE	$F9," SELECT A PIECE TO MOVE",$FA," ",$FB," ",$FC," ",255
MOVE2		BYTE	$F9," SELECT A SPOT TO",$FA," MOVE YOUR PIECE TO",$FB," ",$FC," ",255
MOVEERR1	BYTE 	$F9," SORRY!",$FA," THERE'S NO PIECE THERE!",$FB," ",$FC," PRESS A KEY",255
MOVEERR2	BYTE	$F9," SORRY!",$FA," YOU CAN'T MOVE THE",$FB," COMPUTER'S PIECES!",$FC," PRESS A KEY",255
MOVEERR3	BYTE	$F9," SORRY!",$FA," THAT PIECE CAN'T",$FB," BE MOVED!",$FC," PRESS A KEY",255
MOVEERR4	BYTE	$F9," SORRY!",$FA," THAT PIECE HAS NO",$FB," VALID MOVES!",$FC," PRESS A KEY",255
MOVEERR5	BYTE	$F9," SORRY!",$FA," YOU CAN'T MOVE TO",$FB," THE SAME POSITION!",$FC," PRESS A KEY",255
MOVEERR6	BYTE	$F9," SORRY!",$FA," YOU CAN'T MOVE TO",$FB," THAT SPOT!",$FC," PRESS A KEY",255
YOUWON		BYTE	$F9," HURRAY!",$FA," YOU FOUND THE FLAG!",$FB," YOU WON THE GAME!",$FC," PRESS A KEY",255
YOULOST		BYTE	$F9," TOO BAD...",$FA," THE COMPUTER FOUND!",$FB," YOUR FLAG! YOU LOST.",$FC," PRESS A KEY",255
YOUPKILLED	BYTE	$F9," TOO BAD...",$FA," YOUR PIECE GOT KILLED!",$FB," ",$FC," PRESS A KEY",255
COMPPKILLED	BYTE	$F9," GOOD JOB!",$FA," YOU KILLED ONE OF THE",$FB," COMPUTERS PIECES!",$FC," PRESS A KEY",255
BOTHPKILLED	BYTE	$F9," OH NO!",$FA," BOTH PIECES ARE THE SAME!",$FB," THEY ARE BOTH KILLED NOW!",$FC," PRESS A KEY",255
LEGEND		BYTE	$E1," ",$E2,$DD,"BOMB",$E4,$DD,"FLAG",$E6,$DD,"0 SPY",$E8,$DD,"1 SCOUT",$EA,$DD,"2 MINER",$EC,$DD,"3 CORPORAL",$EE,$DD,"4 LTN",$F0,$DD,"5 CAPTAIN",$F2,$DD,"6 MAJOR",$F4,$DD,"7 COLONEL",$F6,$DD,"8 GENERAL",$F8,$DD,"9 MARSHALL",255
PLAYAGAINT	BYTE	$F9," SO, DO YOU WANT TO",$FA," PLAY AGAIN?",$FB,"",$FC," YES OR NO? (Y/N): ",255
GOODBYE		BYTE	$F9," THAT WAS FUN!",$FA," HOPE TO SEE AGAIN SOON!",$FB," ",$FC," (RESET SYSTEM)",255
EMPTY		BYTE	$E0," ",$E1," ",$E2," ",$E3," ",$E4," ",$E5," ",$E6," ",$E7," ",$E8," ",$E9," ",$EA," ",$EB," ",$EC," ",$ED," ",$EE," ",$EF," ",$F0," ",$F1," ",$F2," ",$F3," ",$F4," ",$F5," ",$F6," ",$F7," ",$F8," ",$F9," ",$FA," ",$FB," ",$FC," ",255

;---------------------------------------------	
;SPRITE DEFINION FILES USED IN THE GAME
;---------------------------------------------
;Load 16x16 sprites into program code.
sprite16:		
	incbin "\Sources\x16-Strategy\Sprites\Sprites_x16.SPR"
sprite16_end:

;Load 32x32 sprites into program code.
sprite32:
	incbin "\Sources\x16-Strategy\Sprites\Sprites_x32.SPR"
sprite32_end:

;Load 64x64 sprites into program code.
sprite64:		
	incbin "\Sources\x16-Strategy\Sprites\Sprites_x64.SPR"
sprite64_end: