z_Regs 		EQU $C0			;We need some Zeropage space for our work
	include "\srcAll\BasicMacros.asm"
SPpage 		EQU $0100

;VERA LABELS
V_L  		EQU $9f20		;VERA_ADDR_HI  IIIIHHHH	20 Bit address H  I=Increment
V_M  		EQU $9f21		;VERA_ADDR_MID MMMMMMMM	20 Bit address M
V_H  		EQU $9f22		;VERA_ADDR_LO  LLLLLLLL	20 Bit address L
V_D1 		EQU $9f23		;VERA_DATA1    DDDDDDDD	Data Port 1
VERA_CTRL 	EQU $9F25 		;$9F25 R------A   R=Reset A=Address (port 1 / 2)

CURSORX		EQU	$4A			;TEXT CURSOR X POSITION (0-39)
CURSORY		EQU	$4B			;TEXT CURSOR Y POSITION (0-27)

CURSORACTION1	EQU	$4D		;VARIABLE FOR CURSOR FIRST ACTION (ENTER) XY POSITION
CURSORACTION2	EQU $4E		;VARIABLE FOR CURSOR SECOND ACTION (ENTER) XY POSITION
CURSORACTION3	EQU $4F		;VARIABLE FOR XY POSITION THAT USED TO BE IN CURSORACTION2, WE CAN USE THIS TO RETURN THE CURSOR TO IT'S LAST SPOT

ZPADDR		EQU	$30			;POINTER TO SET THE START BYTE LOCATION FOR THE 2 BYTE MEM ADDRESS (WHICH WILL STORE THE STRINGS MEMORY START AT $0030 AND $0031)

MONHEX		EQU	$DA			;MEMORY ADDRESS $DA=MEM ADDRESS,$DB=HEX VALUE OF MEM ADDRESS,$DC=MSN OF $DA,$DD=LSN OF $DA,$DE=MSN OF $DA,$DF=LSN OF $DA (SEE PMONITOR SUB)
KENTER		EQU	$0D			;ENTER KEY ON KEYBOARD IS #0D
CR			EQU	$0D			;CR $0D IS CARRIAGE RETURN

GETIN		EQU $FFE4		;GETIN reads a single byte from default input
							;returns #0 if no key is pressed = non-blocking
CLOCKAPI	EQU $FF50		;COMMANDER X16 KERNAL_API CALL CLOCK_GET_DATE_TIME, RESULT: YEAR=$02,MONTH=$03,DAY=$04,HOURS=$05,MINUTES=$06,SECONDS=$07,JIFFIES=$08.
CLOCKSEC	EQU $07

CHRBUF		EQU	$10 		;$10.$2F - USED TO STORE PLAYER TYPED TEXT (MAX 30 CHARACHTERS, MUST END WITH VALUE 00 AFTER LAST LETTER). $2F CONTAINS AMOUNT OF LETTERS!
CHRBUFC		EQU	$2F
SEED		EQU	$7E			;ZERO PAGE $7E - USED FOR RANDOM NUMBER GENERATOR SEED ($7F ALSO RESERVED FOR TEMP DATA)

SPRITEARRAYH EQU $04		;HIGH BYTE OF THE SPRITE DATA ARRAY
PIECESLEFT	EQU	$0500		;DATA TABLE OF THE 1PIECES LEFT TO PLACE ($0500-$0511)
PIECESLEFTH EQU	$05			;HIGH BYTE OF THE DATA TABLE OF THE PIECES LEFT TO PLACE
VAR_PIECES	EQU $4C			;VARIABLE USED TO COUNT DOWN FROM 39 PLACEABLE PIECES TO 0.

VAR_SEC		EQU	$45			;LOCATION TO STORE PREVIOUS AMOUNT OF SECONDS
VAR_BLINK	EQU $46			;IS THE BLINKING CURSOR ON OR OFF? (0=OFF/1=ON)
VAR_TEAM	EQU $47			;WHICH TEAM DOES THE PLAYER WANT TO PLAY ? (0=RED, 1=BLUE)
VAR_TURN	EQU $50			;WHICH PLAYER'S TURN IS IT? 0 FOR THE PLAYER'S TURN, 1 FOR THE COMPUTER'S TURN
VAR_ATTACK	EQU $51			;VARIABLE USER TO SHOW THE COMPUTER'S PIECE'S FRONT SIDE DURING A ATTACK (0=NO, 1=YES)
VAR_SPRITESTATUS EQU $52	;STATUS/SIZE OF THE SPRITES, 0=16X16 SPRITE, 1=32X32 SPRITE, 2=64X64 SPRITE, 3=DISABLE SPRITE, USED BY SPRITE DRAW ROUTINE (SETSPRITE)
VAR_PHASE	EQU $53			;KEEPS TRACK WHICH PHASE WE'RE IN, ONLY NEED IT TO KNOW IF WE'RE IN PHASE 1 OR PHASE 2, TO SHOW NR OF PIECES LEFT OF THE PIECES NAMES NEXT TO THE PLAYFIELD
VAR_TURNS	EQU $56			;KEEPS TRACK OF THE TURNS PLAYED IN THE GAME. (DEBUG ONLY)

COMP_INDIV_SCORES	EQU	$60	;USED BY COMPUTER INDIVIDUAL MOVE SCORE ARRAY (4 MOVES, 4 SCORES = 8 BYTES)
COMP_TOT_SCORES_HIGH	EQU	$06	;HIGH BYTE FOR THE COMPUTER TOTAL SCORE DATA ARRAY
COMP_PIECE_OFFSET	EQU $54	;OFFSET FOR THE COMPUTERS SPRITE, IF THE COMPUTER IS PLAYING BLUE, THEN THE OFFSET IS 40, IF IT'S PLAYING RED, THE OFFSET IS 0.
COMP_TMPSCORE		EQU $55	;TEMPORARY LOCATION FOR SCORE CALCULATION

;---------------------------------------------
;COMMANDER X16 - MEMORY MAP SUMMERIZED
;---------------------------------------------
;$0000 - $000F 		!COMMANDER X16 VARIABLES USED BY THE NEW API CALLS. TRY NOT TO USE!
;$0010 - $002F		CHARACTER BUFFER FOR USER TYPED TEXT (30 CHAR MAX)
;$0030 - $0044 		TEMP DATA USED BY VARIOUS FUNCTIONS AND SUBROUTINES, NO FIXED ASSIGNMENT. (ZPADDR)
;$0045 - $0056		VARIABLES USED IN THE GAME
;$0057 - $005F		FREE
;$0060 - $0067		USED BY COMPUTER INDIVIDUAL MOVE SCORE ARRAY (4 MOVES, 4 SCORES = 8 BYTES)
;$0068 - $007D		FREE
;$007E - $007F		RANDOMIZER SEED VARIABLES

;$0080 - $00FF		!COMMANDER X16 KERNAL AND BASIC ZERO PAGE VARIABLES, DO NOT USE! CAN BE USED IN ASM THAT ONLY USES KERNAL, NO BASIC OR FLOATING POINT.
;* $00C0 - $00D0	USED BY CHIBIAKUMAS Z_REGS VARIABLES (BASICFUNCTIONS.ASM) THAT ARE USED AS A BASE FOR THIS PROGRAM (17 BYTES)
;* $00DA - $00DF	USED MY MON1HEX ROUTINE

;$0100 - $01FF		!6502 CPU STACK VALUES, DO NOT USE!
;$0200 - $03FF		!COMMANDER X16 KERNAL AND BASIC VARIABLES AND VECTORS, DO NOT USE!
;$0400 - $0477		RED GAME PIECES DATA ARRAY (3 BYTES PER PIECE) - SPRITES 0 - 39
;$0478 - $04F0		BLUE GAME PIECES DATA ARRAY (3 BYTES PER PIECE) - SPRITES 40 - 79
;$04F1 - $04F3		PLAYER SELECT CURSOR, SPRITE 80
;$04F4 - $04F6		PLAYER PREVIOUSLY SELECTED CURSOR, SPRITE 81
;$04F7 - $04FF		FREE
;$0500 - $0511		STORE THE REMAINING PIECES TO PLACE, $0500 = BOMBS, $0501 = FLAG, ETC..., $0511 = MARSHALL
;$0512 - $05FF		FREE
;$0600 - $0677		120 BYTES USED FOR COMPUTER TOTAL SPRITE SCORE ARRAY (SPRITE NUMBER, MOVE SCORE, XY POSITION,.... (REPEATING FOR 40 PIECES = 120 BYTES)		
;$0801 - 			ASSEMBLED PROGRAM CODE

;$9F00 - $9FFF		!COMMANDER X16 I/O AREA (256 BYTES), DO NOT USE!
;$A000 - $BFFF		!COMMANDER X16 BANKED RAM (8KB WINDOW, 256 BANKS AVAILABLE, TOTAL 2 MB)
;$C000 - $FFFF		!COMMANDER X16 BANKED ROM (16KB WINDOW, 8 BANKS AVAILABLE, TOTAL 128 KB)
;* $FF62 - $FFF3	!COMMANDER X16, KERNAL API CALLS FOR COMMODORE 64/128 COMPATIBILITY.!


;WE NEED TO SETUP A DATA ARRAY FOR THE GAME PIECES, 3 BYTES OF MEMORY PER GAME PIECE.
;1 BYTE FOR THE PIECE / SPRITE NUMBER (0-79) (#%-NNNNNNN)
;1 BYTE FOR X AND Y COORDINATES OF THE PIECE (#%XXXXYYYY)
;1 BYTE FOR PIECE FLAGS AND THE PIECE TYPE (#%DF--TTTT) D=DEAD, D=FOUND, T=TYPE(0=FLAG,1=BOMB,2=SPY,3=SCOUT,4=MINER,5=SERGEANT,6=LIEUTENANT,7=CAPTAIN,8=MAJOR,9=COLONEL,10=GENERAL,11=MARSHALL)

;---------------------------------------------
;COMMANDER X16 - HARDWARE SPRITE USAGE
;---------------------------------------------
;SPRITES 0  - 39	;RED TEAM GAMEPIECES
;SPRITES 40 - 79	;BLUE TEAM GAMEPIECES
;SPRITE  80			;PLAYER CURSOR
;SPRITE  81			;PLAYER CURSOR (PREVIOUSLY SELECTED GAMEPIECE)
;SPRITES 82 - 94	;LEGEND \ REMAINING PLACEABLES TO THE RIGHT OF THE PLAYFIELD
;SPRITES 100-117	;SPRITES USED TO BUILD THE (BACKGROUND) PLAYFIELD


	macro SetVeraAddr,val		;SetVeraHML $123456
		lda #(\val>>16 & $FF)		;$12
		sta V_H	
		
		lda #(\val>>8 & $FF)		;$34
		sta V_M
		
		lda #(\val & $FF)			;$56
		sta V_L
	endm
	

*=$0801		
		;Alternative header (saves 3 bytes on the header above)
		BYTE $0B,$08,$01,$00,$9E,$32,$30,$36,$31,$00,$00,$00  ;Start at $080D
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;Screen Setup
	
	     ;R------A		R=Reset A=Address (port 1 / 2)
	lda #%00000000
	sta VERA_CTRL  		;$9F25 - set ADDR1 active
	
	SetVeraAddr $1F0000 ;$F0000 address with inc DC_VIDEO 
	
		 ;F----COO		F=current field (RO) 
	lda #%00000001		;C=Chroma disable O=Out mode (1=vga)	 
	sta V_D1 			;$40040	DC_VIDEO 

	lda #64				; Hscale - 128=Normal 64=2x
	sta V_D1 			;$40041	DC_HSCALE
	
	lda #64				; Vscale - 128=Normal 64=2x
	sta V_D1 			;$40042	DC_VSCALE
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;PALLET SETUP
	SetVeraAddr $1F1000	;$40200	Color 0 Green/Blue

	ldx #2				;2 bytes x 256 entries ($GB $-R )
	ldy #0
	lda #<palette
	sta z_l
	lda #>palette
	sta z_h
	
PaletteLoop:	
	lda (z_hl),y		
	sta V_D1		
	iny
	bne PaletteLoop
	inc z_h
	dex
	bne PaletteLoop
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;LAYER 0 SETUP
	SetVeraAddr $1F2000 	;L1_CTRL0 (AUTOINC $01)
	
		 ;MMM----E M=MODE E=ENABLE (MODE 6=4BPP)
	lda #%11000001
	sta V_D1		;$40000	L1_CTRL0		MMM----E	(M=Mode E=Enable)
	stz V_D1		;$40001	L1_CTRL1		--HWhhww	H=tile Height / W=tile Width / m=map height / w=map width
	stz V_D1		;$40002	L1_MAP_BASE_L 	LLLLLLLL	Map Base (9:2)
	stz V_D1		;$40003	L1_MAP_BASE_H	HHHHHHHH	Map Base (17:10)

	;Layer at $000000-$009600
	stz V_D1		;$40004	L1_TILE_BASE_L 	LLLLLLLL	Tile Base (9:2)		
	stz V_D1		;$40005	L1_TILE_BASE_H  HHHHHHHH	Tile Base (17:10)
	
	stz V_D1		;$40006	L1_HSCROLL_L	LLLLLLLL	Hscroll (7:0)
	stz V_D1		;$40007	L1_HSCROLL_H 	----HHHH	Vscroll (11:8)
	stz V_D1		;$40008	L1_VSCROLL_L  	LLLLLLLL	Hscroll (7:0)
	stz V_D1		;$40009	L1_VSCROLL_H 	----HHHH	Vscroll (11:8)
	
	;LAYER 1 SETUP (WE'RE GOINT TO DISABLE THIS LAYER TO PREVENT ARTIFACTS ON SCREEN)
	SetVeraAddr $1F3000 	;L1_CTRL0 (Autoinc $01)
	
	lda #%00000000
	sta V_D1		;$F3000 L1_CTRL0	
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;LETS CLEAR ALL THE PIXELS OF THE SCREEN, FILL THEM ALL WITH BLACK PIXELS (WONT CLEAR SPRITES)
	JSR CLEANSCREENPIXELS
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;Enable sprites in VERA (One command to turn all Sprites on.)
	SetVeraAddr $1F4000	;Enable Sprites register ($F4000 with autoincrement (1) on)
	LDA #1
	STA V_D1			;Turn the prite on

	;Copy 16x16 Sprites BMP to VERA VRAM (128 bytes per Sprite of VRAM)
	SetVeraAddr $110000	;Dest Addr for Sprite Bitmaps
	LoadPair z_hl,sprite16
	LoadPair z_bc,(sprite16_end-sprite16)
	JSR VLDIR			;Copy Sprite data to VRAM
	
	;Copy 32x32 Sprites BMP to VERA VRAM (512 bytes per Sprite of VRAM, VRAM reserverd for 8x Sprites, 4096 Bytes)
	SetVeraAddr $119000	;Dest Addr for Sprite Bitmaps
	LoadPair z_hl,sprite32
	LoadPair z_bc,(sprite32_end-sprite32)
	JSR VLDIR			;Copy Sprite data to VRAM
	
	;Copy 64x64 Sprites BMP to VERA VRAM (2048 bytes per Sprite of VRAM)
	SetVeraAddr $11A000	;Dest Addr for Sprite Bitmaps
	LoadPair z_hl,sprite64
	LoadPair z_bc,(sprite64_end-sprite64)
	JSR VLDIR			;Copy Sprite data to VRAM
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GAME PHASE 0, INITIALIZE AND PREPARE THE GAME
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PHASE0:
	JSR RNDINIT			;INITIALIZE THE RND GENERATOR
	JSR SHOWPLAYFIELD	;SHOW THE PLAYFIELD SPRITES ON SCREEN
	JSR INITPHASE0VARS	;INITIALIZE AND RESET THE VARIABLES AND SPRITE DATA ARRAY
	
	LDA #<ASKSIDE		;ASK THE PLAYER WHICH SIDE TO PLAY (RED/BLUE)
	STA z_L
	LDA #>ASKSIDE
	STA z_H
	JSR PrintString
	JSR CINPUT			;CAPTURE USER INPUT (1 CHARACTER)
	
	LDA CHRBUF			;LOAD THE FIRST CHARACTER IN THE CHARACTER BUFFER
	CMP #$42 			;CHECK IF THE FIRST CHARACTER IN THE BUFFER IS #66 = B			
	BEQ TEAMBLUESEL		;IF IT'S B FOR BLUE, BRANCH TO BLUE TEAM SELECT
	STZ VAR_TEAM		;IF IT'S NOT B, THEN STORE 0 FOR TEAM RED IN VAR_TEAM
	JMP TEAMSELDONE
TEAMBLUESEL:
	LDA #1
	STA VAR_TEAM		;IF THE PLAYER WANTS THE BLUE TEAM, THEN STORE 1 IN VAR_TEAM
TEAMSELDONE:
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GAME PHASE 1, PLACEMENT OF THE GAME PIECES BY THE COMPUTER AND PLAYER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	LDA #1
	STA VAR_PHASE		;STORE 1 IN VAR_PHASE, SO THE GAME KNOW'S WE ARE IN PHASE 1 NOW.
	;FIRST THE COMPUTER WILL PLACE THE GAME PIECES DOWN
	JSR INITPHASE1VARS	;INITIALIZE THE VARS FOR HOW MANY PIECES AND HOW MANY OF EACH GAME PIECE LEFT FOR THE COMPUTER
	JSR COMPUTERPHASE1	;HAVE THE COMPUTER PLACE HIS GAME PIECES DOWN	
	
	;NOW THE PLAYER WILL PUT HIS PIECES DOWN
	JSR INITPHASE1VARS	;RESET THE PHASE1 VARS AGAIN, SO THE PLAYER CAN SEE HOW MANY OF EACH PIECE LEFT TO PLACE

	;CHECK WHICH TEAM THE PLAYER PLAYS AND ADD THE NESSECARY OFFSETS TO SPRITE NUMBER AND VERA VRAM ADDRESS
	LDA VAR_TEAM
	CMP #0				;CHECK IF VAR_TEAM IS SET TO 0, IF IT IS, WE NEED TO LOAD THE RED SPRITES FOR THE PLAYER
	BEQ PHASE1PLAYEROFFSETA	;IF IT IS, THEN WE NEED TO LOAD THE BLUE TEAM FOR THE PLAYER
	LDA VAR_PIECES		;LOAD THE NUMBER OF PIECES STILL TO ADD	
	CLC
	ADC #40				;SINCE THE PLAYER WILL PLAY ON THE BLUE TEAM WE NEED TO ADD 40 TO THE PIECES LEFT (SO THE PLAYER WILL PLAY SPRITES 40-79)
	STA ZPADDR+9		;AND STORE THE NEW SPRITE NUMBER IN ZPADDR+9
	JMP PHASE1PLAYERPIECE	;HOP OVER TO PLAYERPIECEPLACEMENT_3B
PHASE1PLAYEROFFSETA:
	LDA VAR_PIECES		;IF THE PLAYER IS THE RED TEAM, LOAD THE NUMBER OF PIECES LEFT
	STA ZPADDR+9		;AND STORE IN ZPADDR+9

PHASE1PLAYERPIECE:
	LDA #<PLACE1		;ASK PLAYER TO SELECT A LOCATION TO PLACE A PIECE DOWN
	STA z_L
	LDA #>PLACE1
	STA z_H
	JSR PrintString
	JSR SHOWPLACEABLES	;SHOW PLACEABLE PIECES SPRITES
	JSR PHASE1MOVECURSORWRAPPER		;ALLOW THE PLAYER TO MOVE THE CURSOR OVER THE PLAYFIELD AND EXIT WITH ENTER.
	
	LDA #80
	JSR GETSPRITEDATA	;GET THE SPRITE DATA FOR SPRITE 80 (CURSOR)
	
	LDA ZPADDR+2		;GET CURSOR X POSITION ON THE PLAYFIELD
	STA ZPADDR+11		;STORE IN ZPADDR+11, WE'LL NEED IT TO PLACE THE SPRITE DOWN ON SCREEN
	ASL					;BITSHIFT TO THE LEFT (000XXXX0)
	ASL					;BITSHIFT TO THE LEFT (00XXXX00)
	ASL					;BITSHIFT TO THE LEFT (0XXXX000)
	ASL					;BITSHIFT TO THE LEFT (XXXX0000)
	STA CURSORACTION1	;STORE X IN CURSORACTION 1
	LDA ZPADDR+3		;GET CURSOR Y POSITION ON THE PLAYFIELD
	STA ZPADDR+12		;STORE IN ZPADDR+11, WE'LL NEED IT TO PLACE THE SPRITE DOWN ON SCREEN
	CLC
	ADC	CURSORACTION1	;ADD CURSOR X TO CURSOR Y POSITION
	STA CURSORACTION1	;STORE XY POSITION TO CURSORACTION 1
	
	;CHECK IF THE PLAYER WANTS TO PLACE ON THE 5TH OR 6TH LINE (IN THE MIDDLE), THAT'S AN INVALID PLACE TO PUT THE PIECES DOWN
	LDA ZPADDR+3		;LOAD THE Y POSITION AGAIN
	CMP #4				;CHECK IF THE PLAYER WANTS TO PLACE ANYTHING ON THE 5TH LINE (NOT ALLOWED!)
	BNE PHASE1PLAYERPIECE_A	;IF NOT, CHECK FOR THE 6TH LINE
	BEQ PHASE1PLAYERPIECE_ERR	;IF THE PLAYER DOES, THEN SHOW ERROR MESSAGE
PHASE1PLAYERPIECE_A:
	CMP #5
	BNE PHASE1PLAYERPIECE_B	;IF NOT, THEN CONTINUE ON.

PHASE1PLAYERPIECE_ERR:
	LDA #<PLACEERR3		;SHOW ERROR, WRONG SPOT SELECTION!
	STA z_L
	LDA #>PLACEERR3
	STA z_H
	JSR PrintString
	JSR CINPUT			;WAIT FOR PLAYER TO PRESS A KEY
	JMP PHASE1PLAYERPIECE	;GO PLACE NEXT PIECE
	
PHASE1PLAYERPIECE_B:
	LDA CHRBUF			;LOAD THE CHARACTER BUFFER`
	CMP #$0D			;CHECK FOR THE RETURN KEY
	BNE	PHASE1PLAYERPIECE_1	;IF IT'S NOT RETURN, THEN SKIP OVER THE NEXT PART
	
	LDA #<PLACE2		
	STA z_L
	LDA #>PLACE2
	STA z_H
	JSR PrintString		;ASK PLAYER TO CHOOSE WHICH PIECE TO PLACE
	JSR SHOWPLACEABLES	;SHOW PLACEABLE PIECES SPRITES, WE NEED TO DO THIS AGAIN, BECAUSE THE TEXT ABOVE WILL HAVE WIPED THE AMOUNT OF MARSHALLS LEFT TO PLACE
	JSR CINPUT			;CAPTURE USER INPUT (1 CHARACTER)
	
PHASE1PLAYERPIECE_1:
	JSR PLAYERPIECEPLACEMENT	;CHECK PLAYER PIECE PLAYMENT CHOICE AND PLACE IF POSSIBLE
	
	LDA VAR_PIECES
	CMP #255			;CHECK IF THE NUMBER OF PIECES LEFT TO PLACE IS 255, IT SHOULD BE 39-0, WHERE 0 IS STILL THE LAST PIECE LEFT TO PLACE
	BNE PHASE1PLAYERPIECE	;IF IT'S NOT, THEN THERE'S MORE PIECES TO PLACE, PLACE NEXT ONE

	LDA #2
	STA VAR_PHASE		;STORE 2 IN VAR_PHASE, SO THE GAME KNOW'S WE ARE IN PHASE 2 NOW.
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GAME PHASE 2, MOVEMENT OF THE PLAYER PIECES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;THERE ARE 9 CHECKS THAT HAVE TO BE PASSED TO CONSIDER THE MOVE VALID:
	;1) THE SOURCE PIECE CAN'T BE A EMPTY FIELD (CAN'T MOVE A EMPTY FIELD AROUND)
	;2) THE SOURCE PIECE CAN'T BE ONE OF THE COMPUTER'S PIECES
	;3) THE SOURCE PIECE CAN'T BE A IMMOVABLE PIECE (BOMB/FLAG)
	;4) THE SOURCE PIECE CAN'T BE BOXED IN ON ALL SIDES (NO WHERE TO MOVE IT)
	;5) THE DESTINATION PIECE CAN'T BE THE SAME AS THE SOURCE PIECE
	;6) THE DESTINATION PIECE CAN'T BE ONE OF THE PLAYER'S OWN PIECES (OTHER OPTIONS ARE A EMPTY FIELD OR A COMPUTER PIECE, BOTH ARE FINE)
	;7) THE DESTINATION CAN'T BE ON THE OBSTACLES (THE CASTLES) IN THE MIDDLE OF THE FIELD
	;8) THE DESTINATION CAN'T BE DIAGONAL FROM THE SOURCE LOCATION, ONLY X OR Y MOVEMENT ALLOWED, NOT BOTH.
	;9) THE DESTINATION CAN'T BE MORE THEN 1 FIELD AWAY FROM THE SOURCE, UNLESS THE SOURCE PIECE IS A SCOUT
	;10) IF SOURCE PIECE IS A SCOUT, CHECK THAT THE FIELDS IN BETWEEN THE SOURCE AND DESTINATION ARE EMPTY (JUMPING OVER PIECES IS NOT ALLOWED)
PHASE2:
	LDA CURSORACTION3		;LOAD CURSORACTION3 (XY POSITION OF CURSOR LAST TIME PHASE2 WAS COMPLETED)
	AND #%00001111			;APPLY BITMASK, LEAVING ONLY Y POSITION 
	TAY						;TRANSFER REMAINING VALYE TO Y REGISTER
	LDA CURSORACTION3		;RELOAD CURSORACTION3
	AND #%11110000			;APPLY BITMASK, LEAVING ONLY X POSITION (XXXX0000)
	LSR						;BITSHIFT TO THE RIGHT (0XXXX000)
	LSR						;BITSHIFT TO THE RIGHT (00XXXX00)
	LSR						;BITSHIFT TO THE RIGHT (000XXXX0)
	LSR						;BITSHIFT TO THE RIGHT (0000XXXX)
	TAX						;STORE REMAINING VALUE IN X REGISTER
	LDA #80					;LOAD THE SPITE NUMBER FOR THE CURSOR
	JSR MOVEPIECE			;MOVE THE CURSOR TO X AND Y FROM CURSORACTION3, BUT DON'T SHOW IT YET
	
PHASE2_0:
	LDA #<MOVE				;ASK PLAYER TO SELECT A PIECE TO MOVE
	STA z_L
	LDA #>MOVE
	STA z_H
	JSR PrintString
	JSR SHOWPLACEABLES			;SHOW PLACEABLE PIECES SPRITES
	JSR PHASE2MOVECURSORWRAPPER		;ALLOW THE PLAYER TO MOVE THE CURSOR OVER THE PLAYFIELD AND EXIT WITH ENTER.
	JSR CHECKVALIDPIECE1	;CHECK IF THE SELECTED PIECE IS A VALID GAME PIECE TO MOVE
	
	LDA CURSORACTION1		;LOAD CURSORACTION1, WHICH CONTAINS THE SELECTED XY POSITION OF THE CURSOR. IF IT FAILED CHECK 1, 2, 3 OR 4, IT WILL CONTAIN 255
	CMP #255				;COMPARE IT TO 255
	BEQ	PHASE2_0			;IF IT MATCHES, THEN GO BACK AND ALLOW THE PLAYER TO SELECT ANOTHER CURSORACTION1...

	JSR SHOWSELCURSOR		;SHOW THE SELECTED CURSOR OVER THE CURRENTLY SELECTED GAMEPIECE
;IF WE GET HERE, WE CAN NOW DO THE SECOND CURSOR ACTION
PHASE2_1:
	LDA #<MOVE2				;ASK PLAYER TO SELECT A SPOT TO MOVE TO
	STA z_L
	LDA #>MOVE2
	STA z_H
	JSR PrintString
	JSR SHOWPLACEABLES			;SHOW PLACEABLE PIECES SPRITES
	JSR PHASE2MOVECURSORWRAPPER		;ALLOW THE PLAYER TO MOVE THE CURSOR OVER THE PLAYFIELD AND EXIT WITH ENTER.
	JSR CHECKVALIDPIECE2	;CHECK IF THE SELECTED PIECE IS A VALID GAME PIECE TO MOVE

	LDA CURSORACTION2		;LOAD CURSORACTION2, WHICH CONTAINS THE SELECTED XY POSITION OF THE CURSOR. IF IT FAILED CHECK 5, 6, 7, 8 OR 9, IT WILL CONTAIN 255
	CMP #255				;COMPARE IT TO 255
	BEQ	PHASE2_1			;IF IT MATCHES, THEN GO BACK AND ALLOW THE PLAYER TO SELECT ANOTHER CURSORACTION1...

	;STORE CURSORACTION2'S LOCATION IN CURSORACTION3 AS WELL, SO WE CAN SET THE CURSOR THERE IF PHASE2 HAPPENS AGAIN
	STA CURSORACTION3		;STORE CURSORACTION2 (STILL IN A) IN CURSORACTION3
	
	;WE'LL NEED TO CHECK IF THE CURSORACTION2 LOCATION RESULTS IN A ATTACKING MOVE, INSTEAD OF JUST A PIECE RE-LOCATION
	JSR CHKPLAYERATTACK		;CHECK IF THE PLAYER'S MOVE IS A ATTACKING MOVE
	CMP #1					;CHECK IF THE RETURNED VALUE IS 1 (YES, IT IS A ATTACKING MOVE)
	BEQ	PHASE2_ATTACK		;IF IT IS A ATTACK, BRANCH TO PHASE2_ATTACK.
	BNE PHASE2_NOATTACK		;IF IT'S NOT A ATTACK, BRANCH TO PHASE2_NOATTACK

PHASE2_ATTACK:
	JMP	PHASE4				;JUMP TO PHASE 4, THE PIECE AT CURSORACTION1 ATTACKING THE PIECE AT CURSORACTION2

PHASE2_NOATTACK:
;IF WE GET TO HERE, THEN ALL 9 CHECKS PASSED, AND THERE IS NO ATTACKING... MOVE THE PIECE AT CURSORACTION1 TO THE LOCATION OF CURSORACTION2
	JSR MOVEPOS1TOPOS2		;MOVE THE PIECE

;NOW WE JUST NEED TO MOVE THE CURSOR'S OFF THE SCREEN
	LDA #80					;LOAD 80 (CURSOR SPRITE NUMBER) IN A
	JSR HIDEPIECE			;HIDE THE CURSOR
	LDA #81					;LOAD THE PREVIOUS SELECTED CURSOR SPRITE NUMBER IN A
	JSR HIDEPIECE			;HIDE THE PREVIOUS SELECTED CURSOR
	
;AND NOW THAT THE PLAYER'S TURN IS DONE, JUMP TO PHASE 5 TO SWAP TURNS
	JMP PHASE5
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GAME PHASE 3, MOVEMENT OF THE COMPUTERS PIECES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PHASE3:
	JSR COMPUTERPHASE3		;LET THE COMPUTER MOVE A PIECE BASED ON RANDOM NUMBER GENERATION
	;WE NOW HAVE THE BEST MOVE IN ZPADDR+8 (SCORE), ZPADDR+9 (SPRITE NUMBER), ZPADDR+10 (XY POSITION)

	;IN CASE THE COMPUTER HAS ONLY UNMOVABLE PIECES LEFT (SUCH AS ONLY BOMBS AND FLAGS), 
	; THE SCORE AND XY POSITION WILL BE 00. IF THAT HAPPENS, MAKE THE COMPUTER SKIP A TURN
	;IF WE DON'T DO THIS, THE COMPUTER WILL MOVE ONE OF IT'S PIECES (PROBABLY A DEAD PIECE) BACK ON THE FIELD ON POSITION 00.... WE NEED TO PREVENT THAT
	LDA ZPADDR+8			;LOAD THE BEST MOVE'S SCORE
	CMP #0					;COMPARE THE SCORE T0 0
	BEQ PHASE3_SKIP			;IF IT IS 0, SKIP THE COMPUTER'S MOVE.
	
	;CALCULATE IF THE MOVE IS A ATTACKING MOVE
	JSR CHKCOMPATTACK		;CHECK IF THE COMPUTER'S MOVE IS A ATTACKING MOVE
	CMP #1					;CHECK IF THE RETURNED VALUE IS 1 (YES, IT IS A ATTACKING MOVE)
	BEQ	PHASE3_ATTACK		;IF IT IS A ATTACK, BRANCH TO PHASE2_ATTACK.
	BNE PHASE3_NOATTACK		;IF IT'S NOT A ATTACK, BRANCH TO PHASE2_NOATTACK

PHASE3_ATTACK:
	;WE NEED TO TRANSFER THE XY POSITION OF THE SOURCE PIECE AND DESTINATION ADRRESS TO CURSORACTION1 AND 2 FOR PROPER PROCESSING IN PHASE 4
	LDA ZPADDR+10			;LOAD DESTINATION ADDRESS
	STA CURSORACTION2		;STORE DESTINATION ADDRESS IN CURSORACTION2
	LDA ZPADDR+9			;LOAD THE SPRITE TO MOVE IN A
	JSR GETSPRITEDATA		;GET THE SPRITE DATA FOR THIS SPRITE
	LDA ZPADDR+2			;GET THE SPRITE'S X POSITION
	ASL						;BITSHIFT TO THE LEFT (000XXXX0)
	ASL						;BITSHIFT TO THE LEFT (00XXXX00)
	ASL						;BITSHIFT TO THE LEFT (0XXXX000)
	ASL						;BITSHIFT TO THE LEFT (XXXX0000)
	STA ZPADDR+11			;STORE BITSHIFTED X POSITION TO ZPADDR+121 FOR NOW
	LDA ZPADDR+3			;LOAD SPRITE'S Y POSITION IN A
	CLC
	ADC ZPADDR+11			;ADD THE BITSHIFTED X POSITION TO Y (XXXXYYYY)
	STA CURSORACTION1		;AND STORE THE SOURCE XY POSITION IN CURSORACTION1
	
	JMP	PHASE4				;JUMP TO PHASE 4, THE COMPUTER PIECE ATTACKING THE PIECE AT ZPADDR+10

PHASE3_NOATTACK:
	JSR MOVECOMPPIECE		;MOVE THE COMPUTERS PIECE

PHASE3_SKIP:
;AND NOW THAT THE PLAYER'S TURN IS DONE, JUMP TO PHASE 5 TO SWAP TURNS
	BRA PHASE5
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GAME PHASE 4, ATTACKING ANOTHER PIECE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PHASE4:
	;THESE RULES HAVE TO BE BUILD INTO PHASE 4. ATTACKING PIECE IS A, DEFENDING PIECE IS B:
	;1) IF B IS A FLAG, THEN THE A TEAM WINS THE GAME
	;2) IF B IS A BOMB, THEN A IS KILLED EXCEPT WHEN A IS A MINER, THEN B IS KILLED.
	;3) IF A IS THE SAME SPRITE TYPE AS B (EQUAL PIECES), THEN BOTH PIECES ARE REMOVED FROM THE BOARD.
	;4) IF B IS A MARSHALL, THEN A IS KILLED, EXCEPT WHEN A IS A SPY, THEN B IS KILLED.
	;5) WHEN A'S PIECE TYPE > B'S PIECE TYPE THEN B IS KILLED. OTHERWISE A IS KILLED. (HIGHER RANK KILLS LOWER RANK)
	
	JSR HANDLEATTACK		;HANDLE THE ATTACKING OF TWO PIECES
	LDA #80
	JSR HIDEPIECE
	LDA #81
	JSR HIDEPIECE			;HIDE THE TWO CURSORS (SPRITE 80 AND 81)
	
	;NOW THAT THE ATTACKING PART IS DONE, WE MOVE ON TO PHASE 5 TO SWAP THE TURNS
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GAME PHASE 5, CHECK WHO'S TURN IT IS, AND SWAP IT FOR THE NEXT MOVE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PHASE5:
	LDA VAR_TURNS			;LOAD THE AMOUNT OF TURNS PLAYED
	CLC
	ADC #1					;INCREMENT BY ONE
	STA VAR_TURNS			;AND STORE THE AMOUNT OF TURNS PLAYED IN VAR_TURNS AGAIN
	
	LDA VAR_TURN
	CMP #0					;CHECK IF IT WAS THE PLAYER TURN
	BEQ PHASE5_COMPUTERNEXT	;IF IT WAS THE PLAYER TURN, THEN IT'S NOW THE COMPUTERS TURN
	;IF NOT, THEN IT WAS THE COMPUTERS TURN, NOW IT'S GOING TO BE THE PLAYER TURN	
	LDA #0
	STA VAR_TURN			;SET THE CURRENT TURN TO THE PLAYER
	JMP PHASE2				;AND JUMP TO PHASE 2, TO LET THE PLAYER MOVE

PHASE5_COMPUTERNEXT:
	LDA #1
	STA VAR_TURN			;SET THE CURRENT TURN TO THE COMPUTER,
	JMP PHASE3				;AND JUMP TO PHASE 3, TO LET THE COMPUTER MOVE
	

	include "\Sources\x16-Strategy\External-Includes.asm"	;LOAD EXTERNAL FILES
