;---------------------------------------------
;FUNCTION - SHOW PLACEABLE PIECES
;THIS FUNCTION WILL SHOW THE PLACEABLE PIECES, THE AMOUNT AND TEXT FOR THEM ON SCREEN
;---------------------------------------------
SHOWPLACEABLES
	;FIRST WE'LL LOAD THE PIECES TO THE LEFT OF THE PLAYFIELD, WE'LL USE SPRITES 82-94 FOR THIS

	STZ ZPADDR			;ZERO OUT ZPADDR, WE'LL USE IF FOR THE SPRITE RAM ADDRESS OFFSET
	
	LDA VAR_TEAM
	CMP #1				;CHECK IF VAR_TEAM IS SET TO 1, IF IT IS, WE NEED TO LOAD THE BLUE SPRITES
	BNE SHOWPLACEABLESR	;IF IT'S NOT, THEN IT'S THE RED TEAM, SO CONTINUE LOADING SPRITES
	LDA ZPADDR			;LOAD THE SPRITE RAM ADDRESS OFFSET
	CLC
	ADC #$34			;ADD $34 TO THE OFFSET, SO WE START WITH THE BLUE SPRITES INSTEAD OF THE RED ONES.
	STA ZPADDR			;AND STORE THE OFFSET

SHOWPLACEABLESR
	LDA #$10			;LOAD $10
	STA ZPADDR+1		;STORE IN ZPADDR+1, WE'LL USE THIS AS THE Y POSITION OF THE SPRITE
	LDA #82
	STA ZPADDR+2		;LOAD #82 IN ZPADDR+2, WE'LL USE THIS AS THE SPRITE NUMBER TO MANIPULATE
	LDX #0				
	STX ZPADDR+3		;SET X/ZPADDR+3 AS THE LOOP COUNTER, WE NEED THE LOOP 12 TIMES.
	LDA #0
	STA VAR_SPRITESTATUS	;STORE 1 IN VAR_SPRITESTATUS, IT WILL BE USED TO TELL THE SETSPRITE FUNCTION TO PRINT A 16X16 SPRITE
	
SHOWPLACEABLESA
	LDA #$08
	STA Z_H				;STORE $08 AS THE HIGH BYTES OF Z_HL
	LDA ZPADDR			
	STA Z_L				;STORE THE ZPADDR VALUE IN THE LOW BYTE OF Z_HL
	LoadPair z_ix,$D0	;SET X POSITION OF SPRITE
	LDA ZPADDR+1		
	STA Z_IYL			;SET Y POSITION OF SPRITE
	LDA ZPADDR+2 		;LOAD THE SPRITE NUMBER IN THE ACCUMULATOR
	JSR SetSprite		;SET THE SPRITE ON SCREEN
	
	LDX ZPADDR+3		;LOAD THE LOOP COUNTER
	CPX #11				;CHECK IF THE LOOP COUNTER IS AT 11 (12 SPRITES PRINTED)
	BEQ SHOWPLACEABLESB	;IF 12 SPRITES HAVE BEEN PRINTED, END PRINTING
	INX					;IF NOT 12 YET, THEN INCREMENT X BY ONE FOR THE NEXT SPRITE
	STX ZPADDR+3		;STORE THE LOOP COUNTER IN ZPADDR+3 AGAIN
	
	LDA ZPADDR
	CLC
	ADC #4				;ADD 4 TO THE LOW BYTE OF THE VERA ADDRESS
	STA ZPADDR			;AND STORE BACK TO ZPADDR
	LDA ZPADDR+1		;NOW LOAD ZPADDR+1 (Y POSITION OF THE SPRITE)
	CLC
	ADC #16				;ADD 16 TO THE SPRITE Y ADDRESS
	STA ZPADDR+1		;AND STORE THE NEW Y POSITION.
	LDX ZPADDR+2		;NOW LOAD THE SPRITE NUMBER
	INX					;ADD 1 TO THE SPRITE NUMBER
	STX ZPADDR+2		;AND STORE THE SPRITE NUMBER AGAIN.
	JMP SHOWPLACEABLESA	;NOW JUMP BACK TO LOAD THE NEXT SPRITE
	
SHOWPLACEABLESB
	LDA VAR_PHASE		;LOAD WHICH PHASE WE'RE IN, (PHASE 1 OR 2 IS THE ONLY RELEVANT)
	CMP #2				;CHECK IF WE'RE IN PHASE 2
	BEQ SHOWPLACEABLESB_LEGEND	;BRANCH TO PRINT THE NAMES OF THE SPRITES NEXT TO THEM
	;OTHERWISE WE;RE IN PHASE 1...
	JSR SHOWPIECESLEFT	;PRINT THE AMOUNT OF EACH PIECE LEFT NEXT TO THE SPRITES
	BRA SHOWPLACEABLESY	;NOW BRANCH TO THE END OF THE FUNCTION
	
SHOWPLACEABLESB_LEGEND
	JSR SHOWLEGEND		;PRINT NAMES AND VALUE OF EACH PIECE LEFT NEXT TO THE SPRITES
	;BRANCH NOT NEEDED, IT'S THE NEXT LINE ANYWAY
SHOWPLACEABLESY
	RTS					;RETURN TO PREVIOUS CODE
	
;---------------------------------------------
;FUNCTION - INIT PHASE 1 PIECES ARRAYS, THIS FUNCTION WILL RESET THE DATA ARRAYS OF THE PIECES
;HOW MANY OF EACH PIECES ARE LEFT TO PLACE AND HOW MANY PIECES LEFT TO PLACE IN TOTAL
;THIS FUNCTION WILL BE CALLED ONES FOR THE COMPUTER AND ONES FOR THE PLAYER.
;---------------------------------------------
INITPHASE1VARS
	;NOW LETS SET THE PIECES REMAINING TO PLACE BY THE PLAYER
	;$0500 - $0511		STORE THE REMAINING PIECES TO PLACE, $0500 = BOMBS, $0501 = FLAG, ETC..., $0511 = MARSHALL
	;- Scout 8x (TYPE 3)
	;- Bomb 6x (TYPE 0)
	;- Miner 5x (TYPE 4)
	;- Sergeant 4x (TYPE 5)
	;- Lieutenant 4x (TYPE 6)
	;- Captain 4x (TYPE 7)
	;- Major 3x (TYPE 8)
	;- Colonel 2x (TYPE 9)
	;- Flag 1x (TYPE 1)
	;- Spy 1x (TYPE 2)
	;- General 1x (TYPE 10)
	;- Marshall 1x (TYPE 11)
	LDX #8
	STX PIECESLEFT+3		;8X SCOUTS
	DEX
	DEX
	STX PIECESLEFT			;6X BOMBS
	DEX
	STX PIECESLEFT+4		;5X MINER
	DEX
	STX PIECESLEFT+5		;4X SARGEANT
	STX PIECESLEFT+6		;4X LIEUTENANT
	STX PIECESLEFT+7		;4X CAPTAIN
	DEX
	STX PIECESLEFT+8		;3X MAJOR
	DEX
	STX PIECESLEFT+9		;2X COLONEL
	DEX
	STX PIECESLEFT+1		;1X FLAGS
	STX PIECESLEFT+2		;1X SPY
	STX PIECESLEFT+10		;1X GENERAL
	STX PIECESLEFT+11		;1X MARSHALL
	
	LDA #39
	STA VAR_PIECES			;STORE 39 IN VAR_PIECES, THE AMOUNT OF PIECES THE PLAYER HAS TO PLACE DOWN.
	
	LDA #$06
	STA CURSORACTION3		;STORE $06 IN CURSORACTION3, SO THE FIRST TIME THE PLAYER GETS A CURSOR, IT STARTS AT X=0 AND Y=6

INITPHASE1VARSY
	RTS						;RETURN BACK TO THE PREVIOUS FUNCTIONS
	
;---------------------------------------------
;FUNCTION - SHOW PIECES LEFT, THIS FUNCTION SHOWS HOW MANY PIECES ARE LEFT TO PLACE ON THE FIELD
;---------------------------------------------
SHOWPIECESLEFT

	LDA #2
	STA ZPADDR			;STORE 3 IN ZPADDR, WE'LL USE THIS AS THE Y POSITION OF THE CURSOR
	LDA #30
	STA ZPADDR+1		;STORE 30 IN ZPADDR+1, THIS WILL BE THE X POSITION OF THE CURSOR
	STZ ZPADDR+2		;STORE 0 IN ZPADDR+2, THIS WILL BE THE LOOP COUNTER
	
	LDA #<PIECESLEFT	;GET THE LOW BYTE OF THE PIECESLEFT TABLE
	STA ZPADDR+3		;STORE THE LOW BYTE IN ZPADDR+3
	LDA #>PIECESLEFT	;GET THE HIGH BYTE OF THE PIECESLEFT TABLE
	STA ZPADDR+4		;STORE THE HIGHT BYTE IN ZPADDR+4
	
SHOWPIECESLEFTA
	LDA ZPADDR
	STA CURSORY			;GET THE CURSORY POSITION FROM ZPADDR AND SET THE CURSORY'S POSITION
	LDA ZPADDR+1
	STA CURSORX			;GET THE CURSORX POSITION FROM ZPADDR+1 AND SET THE CURSORX'S POSITION
	
	LDA (ZPADDR+3)		;LOAD THE AMOUNT OF PIECES LEFT
	JSR printhex		;PRINT THE AMOUNT ON THE SCREEN
	LDA #" "
	JSR PRINTCHAR		;PRINT A SPACE
	LDA #"-"
	JSR PRINTCHAR		;PRINT A -
	LDA #" "
	JSR PRINTCHAR		;PRINT A SPACE
	
	LDA ZPADDR+2		;LOAD THE LOOP COUNTER
	CMP #0
	BNE SHOWPIECESLEFTA_1	;COMPARE LOOP COUNTER, AND LOAD B-F-0-1-2-3-4-5-6-7-8-9
	LDA #'B'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_1
	CMP #1
	BNE SHOWPIECESLEFTA_2
	LDA #'F'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_2
	CMP #2
	BNE SHOWPIECESLEFTA_3
	LDA #'0'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_3
	CMP #3
	BNE SHOWPIECESLEFTA_4
	LDA #'1'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_4
	CMP #4
	BNE SHOWPIECESLEFTA_5
	LDA #'2'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_5
	CMP #5
	BNE SHOWPIECESLEFTA_6
	LDA #'3'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_6
	CMP #6
	BNE SHOWPIECESLEFTA_7
	LDA #'4'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_7
	CMP #7
	BNE SHOWPIECESLEFTA_8
	LDA #'5'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_8
	CMP #8
	BNE SHOWPIECESLEFTA_9
	LDA #'6'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_9
	CMP #9
	BNE SHOWPIECESLEFTA_10
	LDA #'7'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_10
	CMP #10
	BNE SHOWPIECESLEFTA_11
	LDA #'8'
	JMP SHOWPIECESLEFTA_1_DONE
SHOWPIECESLEFTA_11
	CMP #11
	;THERE'S NO OTHER OPTIONS AVAILABLE, AND THE JUMP ISNT NEEDED
	LDA #'9'
SHOWPIECESLEFTA_1_DONE
	JSR PRINTCHAR		;PRINT THE F-B-0-1-2-3-4-5-6-7-8-9 ON THE SCREEN
	
	LDX ZPADDR+2		;LOAD THE LOOP COUNTER
	CPX #11				;CHECK IF WE ALREADY DID 12 LOOPS
	BEQ SHOWPIECESLEFTY	;IF WE DID, THEN END THIS FUNCTION
	INX
	STX ZPADDR+2		;IF NOT, INCREMENT X AND STORE BACK IN ZPADDR+2
	LDX ZPADDR+3		;LOAD THE LOW BYTE OF THE PIECESLEFT TABLE
	INX
	STX ZPADDR+3		;INCREMENT BY ONE AND STORE BACK IN ZPADDR+3
	LDA ZPADDR			;LOAD THE Y POSITION OF THE CURSOR
	CLC
	ADC #2
	STA ZPADDR			;ADD 2 AND STORE BACK IN ZPADDR
	JMP SHOWPIECESLEFTA	;GO PRINT THE NEXT AMOUNT OF PIECES
	
SHOWPIECESLEFTY
	RTS					;RETURN TO PREVIOUS FUNCTION

;---------------------------------------------
;FUNCTION - COMPUTER PREPERATION, USED FOR THE COMPUTER TO PLACE THEIR PIECES ON THE FIELD
;---------------------------------------------
COMPUTERPHASE1
;WE ARE GOING TO HAVE THE COMPUTER PLACE DOWN THEIR 40 PIECES IN THE TOP 4 ROWS OF THE GAME FIELD
	
;WE'RE GOING TO PLACE THE FLAG FIRST, AS WE WANT TO DEPLOY IT IN LINE 1 OR 2. 
;GET RANDOM VALUE 0-19 FOR PLACEMENT OF THE FLAG.
	LDA #19				
	JSR RAND			;GET RANDOM VALUE BETWEEN 0 AND 19.
	
	CMP #10				;COMPARE THE RANDOM VALUE TO 10
	BCC	COMPUTERPHASE1_LESS10	;IF IT'S LESS THEN 10, THEN BRANCH TO THERE
	;IF IT'S 10 OR MORE, THEN WE'LL PLACE THE FLAG ON Y=1
	SEC
	SBC #10				;SUBTRACT 10 FROM THE RANDOM NUMBER, THIS WILL BE THE X POSITION OF THE FLAG
	STA ZPADDR+12
	LDA #1
	STA ZPADDR+11		;STORE 1 IN Y POSITION
	JMP COMPUTERPHASE1_LESS10D
	
COMPUTERPHASE1_LESS10	;IF THE RANDOM VALUE IS LESS THEN 10, THEN Y=0, THE RANDOM NUMBER ITSELF CAN BE THE X POSITION.
	STA ZPADDR+12		;STORE RANDOM NUMBER AS X POSITION
	STZ ZPADDR+11		;STORE 0 IN ZPADDR+11, THE Y POSITION OF THE FLAG
	
COMPUTERPHASE1_LESS10D
	;CHECK WHICH TEAM THE COMPUTER PLAYS AND ADD THE NESSECARY OFFSETS TO SPRITE NUMBER AND VERA VRAM ADDRESS
	LDA VAR_TEAM
	CMP #0				;CHECK IF VAR_TEAM IS SET TO 0, IF IT IS, WE NEED TO LOAD THE BLUE SPRITES FOR THE COMPUTER
	BNE COMPUTERPHASE1_0R	;IF IT'S NOT, THEN WE NEED TO LOAD THE RED TEAM FOR THE COMPUTER
	LDA VAR_PIECES		;LOAD THE NUMBER OF PIECES STILL TO ADD	
	CLC
	ADC #40				;SINCE THE COMPUTER WILL PLAY ON THE BLUE TEAM WE NEED TO ADD 40 TO THE PIECES LEFT (SO THE PC WILL PLAY SPRITES 40-79)
	STA ZPADDR+9		;AND STORE THE NEW SPRITE NUMBER IN ZPADDR+9
	JMP COMPUTERPHASE1_0DONE	;HOP OVER TO COMPUTERPHASE1_0DONE
COMPUTERPHASE1_0R
	LDA VAR_PIECES		;IF THE COMPUTER IS THE RED TEAM, LOAD THE NUMBER OF PIECES LEFT
	STA ZPADDR+9		;AND STORE IN ZPADDR+9
COMPUTERPHASE1_0DONE

	;NOW LETS SET THE VARIABLES FOR THE SPRITE (COMPUTER FLAG) IN THE SPRITE DATA ARRAY
	LDA ZPADDR+9		;LOAD PIECES LEFT (+OFFSET FOR BLUE TEAM) / SPRITE NUMBER 
	LDX ZPADDR+12		;SET X POSITION OF SPRITE
	LDY ZPADDR+11		;SET Y POSITION OF SPRITE
	JSR MOVEPIECE		;SET X AND Y POSITION OF SPRITE THE IN SPRITE DATA ARRAY
	LDX #1				;SET PIECE TYPE (FLAG)
	JSR SETPIECETYPE	;SET THE PIECE TYPE IN THE SPRITE DATA ARRAY
	JSR SHOWPIECE		;NOW SHOW/MOVE THE PIECE (FLAG) ON SCREEN
	
	LDY VAR_PIECES		;LOAD THE AMOUNT OF PIECES STILL TO PLACE ON THE FIELD
	DEY
	STY VAR_PIECES		;DECEASE BY ONE (AS THE FLAG IS PLACED) AND STORE AGAIN
	LDY ZPADDR+9
	DEY
	STY ZPADDR+9		;LOAD ZPADDR+9 (SPRITE NUMBER), DECREASE BY ONE AND STORE AGAIN

;--------------------------------------------------------------------
;AND NOW FOR PLACING THE OTHER PIECES, FIRST WE NEED TO DECIDE WHICH TYPE TO PLACE
;AND CHECK IF THAT TYPE HAS ANY PIECES LEFT TO PLACE
;--------------------------------------------------------------------
COMPUTERPHASE1A
	;GENERATE A RANDOM VALUE OF 0 TO 11, FOR THE PIECE NUMBER WE ARE GOING TO PLACE
	LDA #11				;LOAD 11 IN THE ACCUMULATOR, THIS WILL BE THE MAX VALUE WE WANT TO GET
	JSR RAND			;GENERATE A RANDOM VALUE OF 0-11
	STA ZPADDR+10		;STORE THE RANDOM PIECE TYPE IN ZPADDR+10 FOR NOW
	
	CMP #0				;CHECK FOR TYPE 0, THE BOMB
	BNE COMPUTERPHASE1A_1	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE BOMB, WE NEED TO CHECK IF THERE ARE ANY BOMBS LEFT TO PLACE
	LDA PIECESLEFT		;LOAD THE AMOUNT OF BOMBS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A	;IF THERE'S 0 LEFT, THEN WE CANT PLACE A BOMB, TRY ANOTHER NUMBER
	BNE COMPUTERPHASE1B_J	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE

COMPUTERPHASE1B_J
	JMP COMPUTERPHASE1B	;INTERMEDIARY JUMP, THE COMPUTERPHASE1B IS OUT OF REACH OF BRANCH OTHERWISE
	
COMPUTERPHASE1A_1
	CMP #1				;CHECK FOR TYPE 1, THE FLAG
	BNE COMPUTERPHASE1A_2	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE FLAG, THEN TRY AGAIN, AS THE FLAG IS ALREADY ON THE FIELD	
	BEQ COMPUTERPHASE1A
	
COMPUTERPHASE1A_2	
	CMP #2				;CHECK FOR TYPE 2, THE SPY
	BNE COMPUTERPHASE1A_3	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE SPY, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE	
	LDA PIECESLEFT+2	;LOAD THE AMOUNT OF SPIES LEFT
	CMP #0	
	BEQ COMPUTERPHASE1A	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE

COMPUTERPHASE1A_3	
	CMP #3				;CHECK FOR TYPE 3, THE SCOUT
	BNE COMPUTERPHASE1A_4	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE SCOUT, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+3	;LOAD THE AMOUNT OF SCOUTS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE
	
COMPUTERPHASE1A_4	
	CMP #4				;CHECK FOR TYPE 4, THE MINER
	BNE COMPUTERPHASE1A_5	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE MINER, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+4	;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE	
	
COMPUTERPHASE1A_5	
	CMP #5				;CHECK FOR TYPE 5, THE SERGEANT
	BNE COMPUTERPHASE1A_6	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE SERGEANT, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+5	;LOAD THE AMOUNT OF SERGEANTS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE	

COMPUTERPHASE1A_6	
	CMP #6				;CHECK FOR TYPE 6, THE LIEUTENANT
	BNE COMPUTERPHASE1A_7	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE LIEUTENANT, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+6	;LOAD THE AMOUNT OF LIEUTENANTS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE	

COMPUTERPHASE1A_7	
	CMP #7				;CHECK FOR TYPE 7, THE CAPTAIN
	BNE COMPUTERPHASE1A_8	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE CAPTAIN, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+7	;LOAD THE AMOUNT OF CAPTAIN LEFT
	CMP #0
	BEQ COMPUTERPHASE1A_J	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE	

COMPUTERPHASE1A_8	
	CMP #8				;CHECK FOR TYPE 8, THE MAJOR
	BNE COMPUTERPHASE1A_9	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE MAJOR, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+8	;LOAD THE AMOUNT OF MAJORS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A_J	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE	

COMPUTERPHASE1A_J
	JMP	COMPUTERPHASE1A	;INTERMEDIARY JUMP POINT, THE BRANCH IS OUT OF RANGE
	
COMPUTERPHASE1A_9	
	CMP #9				;CHECK FOR TYPE 9, THE COLONEL
	BNE COMPUTERPHASE1A_10	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE COLONEL, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+9	;LOAD THE AMOUNT OF COLONELS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A_J	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE	

COMPUTERPHASE1A_10	
	CMP #10				;CHECK FOR TYPE 10, THE GENERAL
	BNE COMPUTERPHASE1A_11	;IF IT'S NOT, GO CHECK FOR THE NEXT PIECE TYPE
	;IF IT'S THE GENERAL, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+10	;LOAD THE AMOUNT OF GENERALS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A_J	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	
	BNE COMPUTERPHASE1B	;THERE IT AT LEAST 1 LEFT, JUMP TO COMPUTER PHASE 2, WHERE WE HANDLE THE PLACEMENT OF THE PIECE	

COMPUTERPHASE1A_11	
	;THERE'S NO NEED TO CHECK IF THE PIECE IS THE MARSHALL, IT'S THE ONLY OPTION LEFT...
	;IF IT'S THE MARSHALL, WE NEED TO CHECK IF THERE ARE ANY LEFT TO PLACE
	LDA PIECESLEFT+11	;LOAD THE AMOUNT OF MARSHALLS LEFT
	CMP #0
	BEQ COMPUTERPHASE1A_J	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, TRY ANOTHER NUMBER	

;--------------------------------------------------------------------
;NOW THAT WE KNOW THE PIECE WE ARE GOING TO PLACE, WE NEED TO FIND A PLACE TO PUT IT
;--------------------------------------------------------------------
COMPUTERPHASE1B	
	;GENERATE RANDOM NUMBER BETWEEN 0 AND 39, 0-9 IS Y=0, 10-19 IS Y=1, 20-29 IS Y=2, 30-39 IS Y=3
	LDA #39
	JSR RAND			;GENERATE A RANDOM NUMBER BETWEEN 0 AND 39
	CMP #30				
	BCC COMPUTERPHASE1B_0_30	;IF LESS THEN 30, THEN CHECK COMPUTERPHASE1B_0_30
	;IF WE'RE HERE, THE VALUE IS 30 OR MORE 
	SEC
	SBC #30				;SUBTRACT 30 FROM THE RANDOM NUMBER		
	STA ZPADDR+11		;THE REMAINING VALUE CAN BE THE X POSITION
	LDA #3
	STA ZPADDR+12		;SET Y POSITION TO 3.
	JMP COMPUTERPHASE1B_0_DONE
	
COMPUTERPHASE1B_0_30
	CMP #20				
	BCC COMPUTERPHASE1B_0_20	;IF LESS THEN 20, THEN CHECK COMPUTERPHASE1B_0_20
	;IF WE'RE HERE, THE VALUE IS 20 OR MORE
	SEC
	SBC #20				;SUBTRACT 20 FROM THE RANDOM NUMBER		
	STA ZPADDR+11		;THE REMAINING VALUE CAN BE THE X POSITION
	LDA #2
	STA ZPADDR+12		;SET Y POSITION TO 2.
	JMP COMPUTERPHASE1B_0_DONE
	
COMPUTERPHASE1B_0_20
	CMP #10				
	BCC COMPUTERPHASE1B_0_10	;IF LESS THEN 20, THEN CHECK COMPUTERPHASE1B_0_10
	;IF WE'RE HERE, THE VALUE IS 10 OR MORE
	SEC
	SBC #10				;SUBTRACT 10 FROM THE RANDOM NUMBER		
	STA ZPADDR+11		;THE REMAINING VALUE CAN BE THE X POSITION
	LDA #1
	STA ZPADDR+12		;SET Y POSITION TO 1.
	JMP COMPUTERPHASE1B_0_DONE

COMPUTERPHASE1B_0_10
	;IF WE'RE HERE, THEN THE VALUE IS LESS THEN 10
	STA ZPADDR+11		;THE RANDOM VALUE CAN BE THE X POSITION
	STZ ZPADDR+12
	
COMPUTERPHASE1B_0_DONE
	;NOW THAT WE HAVE THE X AND Y POSITION, WE NEED TO COMBINE THEM TO ONE VALUE
	LDA ZPADDR+11		;LOAD THE X POSITION
	ASL					;BITSHIFT TO THE LEFT (000XXXX0)
	ASL					;BITSHIFT TO THE LEFT (00XXXX00)
	ASL					;BITSHIFT TO THE LEFT (0XXXX000)
	ASL					;BITSHIFT TO THE LEFT (XXXX0000)
	STA ZPADDR+13		;STORE X POSITION IN ZPADDR+13 FOR NOW
	
	LDA ZPADDR+12		;LOAD Y POSITION
	CLC
	ADC ZPADDR+13		;ADD THE X POSITION TO THE Y POSITION (XXXXYYYY)
	STA ZPADDR+13		;STORE X AND Y POSITION IN ZPADDR+1 FOR NOW

;NOW WE NEED TO LOOP THROUGH ALL 80 PIECES IN THE SPRITE DATA ARRAY'S 2ND BYTES
;IF WE FIND A POSITION IN THE ARRAY WITH A IDENTICAL X AND Y COORDINATE AS STORED IN ZPADDR+1
;THEN THAT PLACE IS OCCUPIED AND CAN'T BE USED. WE'LL LOOP BACK TO COMPUTERPHASE1B FOR ANOTHER LOCATION
	STZ ZPADDR			;ZERO OUT ZPADDR, WE'LL USE THIS AS A LOOP COUNTER
	LDA #$04			
	STA ZPADDR+4		;STORE $04 IN ZPADDR+4, WE'LL USE THIS AS THE HIGH BYTE OF THE SPRITE DATA ARRAY
	LDA #1
	STA ZPADDR+3		;STORE 1 IN ZPADDR+3, WE'LL USE THIS FOR THE LOW BYTE OF THE SPRITE DATA ARRAY (OFFSET BY ONE SO WE GET THE SECOND BYTE OF THE ARRAY)
	
COMPUTERPHASE1B_1
	LDA (ZPADDR+3)		;LOAD THE X AND Y POSITION OF THE PIECE IN THE SPRITE DATA ARRAY
	CMP ZPADDR+13		;COMPARE THIS XY POSITION TO THE XY POSITION WHERE WE WANT TO PLACE THE PIECE DOWN
	BEQ	COMPUTERPHASE1B_2	;IF IT FINDS A MATCH, THEN THIS XY POSITION IS ALREADY TAKEN, FIND ANOHER XY POSITION	
	
	;IF THIS XY POSITION IS NOT TAKEN, WE NEED TO CHECK THE NEXT GAME PIECE
	LDX ZPADDR			;LOAD THE LOOP COUNTER
	CPX #79				;SEE IF WE HAVE ALREADY CHECKED ALL 80 GAME PIECES AND THEIR LOCATIONS
	BEQ COMPUTERPHASE1C	;IF WE HAVE, END THE LOOP, AND GO TO COMPUTERPHASE1C, WHERE WE WILL PLACE THE PIECE
	;IF WE HAVENT CHECKED ALL 79 YET, THEN LOOP AGAIN
	INX
	STX ZPADDR			;INCREMENT THE PIECE/LOOP COUNTER
	LDA ZPADDR+3		;LOAD THE SPRITE ARRAY LOW BYTE
	CLC
	ADC #3
	STA ZPADDR+3		;ADD 3 TO IT AND STORE IT AGAIN, FOR THE NEXT LOOP
	JMP COMPUTERPHASE1B_1	;AND LOOP AGAIN TO CHECK THE NEXT PIECE

COMPUTERPHASE1B_2		;CODE GOES HERE IF IT FOUND A MATCH IN THE COORDINATES (ALREADY USED BY ANOTHER PIECE)
	JMP COMPUTERPHASE1B

;NOW THAT WE KNOW WHAT PIECE TO PLACE DOWN, AND WHERE TO PLACE IT DOWN, WE NEED TO ACTUALL DO SO
;FIRST THOUGH, WE'LL UPDATE THE DATA ARRAY THAT THERE IS NOW 1 LESS PIECE OF THAT TYPE LEFT TO PLACE DOWN
COMPUTERPHASE1C			;CODE GOES HERE, IF IT FOUND A SPOT.

	;SO FIRST LETS UPDATE THE PIECES LEFT DATA ARRAY
	LDA #PIECESLEFTH
	STA ZPADDR+1		;LOAD THE HIGH BYTE OF THE PIECES LEFT DATA ARRAY AND STORE IN ZPADDR+1 (HIGH BYTE)
	LDA ZPADDR+10		;LOAD THE PIECE TYPE IN THE ACCUMULATOR
	STA ZPADDR			;AND STORE IT IN ZPADDR, WHICH WILL BE USED AS THE LOW BYTE
	
	LDA (ZPADDR)		;NOW LOAD THE AMOUNT OF PIECES LEFT FROM THE PIECES LEFT DATA ARRAY (OFFSET BY TYPE)
	SEC
	SBC #1				;DECREASR THE AMOUNT BY 1
	STA (ZPADDR)		;AND STORE IT AGAIN WITH IT'S NEW VALUE	

	;AND HERE WE WILL ACTUALLY UPDATE DE SPRITE DATA ARRAY AND PLACE THE GAME PIECE DOWN
	LDA ZPADDR+9		;LOAD THE SPRITE NUMBER (ALREADY OFFSET FOR RED/BLUE TEAM)
	LDX ZPADDR+11		;SET X POSITION OF SPRITE
	LDY ZPADDR+12		;SET Y POSITION OF SPRITE
	JSR MOVEPIECE		;SET X AND Y POSITION OF SPRITE THE IN SPRITE DATA ARRAY
	LDX ZPADDR+10		;SET PIECE TYPE
	JSR SETPIECETYPE	;SET THE PIECE TYPE IN THE SPRITE DATA ARRAY
	JSR SHOWPIECE		;NOW SHOW/MOVE THE PIECE (FLAG) ON SCREEN
	
;NOW THAT THE PIECE IS PLACED AND THE DATA ARRAY UPDATED, LET'S SEE IF WE NEED TO PLACE MORE PIECES
	LDY VAR_PIECES		;LOAD THE AMOUNT OF PIECES STILL TO PLACE ON THE FIELD
	CPY	#0				;CHECK IF THE AMOUNT OF PIECES LEFT TO PLACE IS AT 0
	BEQ	COMPUTERPHASE1Y	;IF THE LAST PIECE HAS BEEN PLACED DOWN, WE CAN END THIS SUBROUTINE
	
	;IF THE LAST PIECE IS NOT YET PLACED, THEN PREPARE TO PLACE THE NEXT 
	DEY
	STY VAR_PIECES		;DECEASE BY ONE (AS THE FLAG IS PLACED) AND STORE AGAIN
	LDY ZPADDR+9
	DEY
	STY ZPADDR+9		;LOAD ZPADDR+9 (SPRITE NUMBER), REDUCE BY 1, AND STORE AGAIN
	
	JMP COMPUTERPHASE1A	;GO BACK TO SELECT THE NEXT PIECE TO PLACE DOWN
	
COMPUTERPHASE1Y
	RTS
	

;---------------------------------------------
;FUNCTION - PLAYER PIECE PLACEMENT CHECKING
; HERE WE'RE GOING TO CHECK WHICH PIECE THE PLAYER WANTED TO PLACE DOWN, CHECK IF HE/SHE CAN (ANY PIECES OF THAT TYPE LEFT AND LOCATION NOT TAKEN), THEN PLACE IT DOWN
;---------------------------------------------
PLAYERPIECEPLACEMENT
	;THIS FUNCTION STARTS RIGHT AFTER THE PLAYER HAS BEEN ASKED TO CHOOSE WHICH PIECE TO PLACE
	;0-9+G+M AS OPTIONS. THE RESULT IS IN THE CHARACTER BUFFER
	
;STEP 1, WHICH OPTION DID THE PLAYER CHOOSE,
	LDA CHRBUF				;LOAD THE FIRST CHARACTER IN THE CHARACTER BUFFER
	
	CMP #$42 				;CHECK IF THE SELECTED OPTION IS "B" (HEX 42)		
	BNE PLAYERPIECEPLACEMENT_1_CHK2		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "B", PLAYER SELECTED BOMB
	LDA PIECESLEFT			;LOAD THE AMOUNT OF BOMBS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_1_JMP	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #0
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2
	
PLAYERPIECEPLACEMENT_1_CHK2
	CMP #$46 				;CHECK IF THE SELECTED OPTION IS "F" (HEX 46)		
	BNE PLAYERPIECEPLACEMENT_1_CHK3		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "F", PLAYER SELECTED FLAG
	LDA PIECESLEFT+1		;LOAD THE AMOUNT OF FLAGS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_1_JMP	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #1
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2
	
PLAYERPIECEPLACEMENT_1_CHK3
	CMP #$30 				;CHECK IF THE SELECTED OPTION IS "0" (HEX 30)		
	BNE PLAYERPIECEPLACEMENT_1_CHK4		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "0", PLAYER SELECTED SPY
	LDA PIECESLEFT+2		;LOAD THE AMOUNT OF SPIES LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_1_JMP	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #2
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK4
	CMP #$31 				;CHECK IF THE SELECTED OPTION IS "1" (HEX 31)		
	BNE PLAYERPIECEPLACEMENT_1_CHK5		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "1", PLAYER SELECTED SCOUT
	LDA PIECESLEFT+3		;LOAD THE AMOUNT OF SCOUTS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_1_JMP	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #3
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK5
	CMP #$32 				;CHECK IF THE SELECTED OPTION IS "2" (HEX 32)		
	BNE PLAYERPIECEPLACEMENT_1_CHK6		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "2", PLAYER SELECTED MINER
	LDA PIECESLEFT+4		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_1_JMP	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #4
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK6
	CMP #$33 				;CHECK IF THE SELECTED OPTION IS "3" (HEX 33)		
	BNE PLAYERPIECEPLACEMENT_1_CHK7		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "3", PLAYER SELECTED MINER
	LDA PIECESLEFT+5		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_1_JMP	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #5
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK7
	CMP #$34 				;CHECK IF THE SELECTED OPTION IS "4" (HEX 34)		
	BNE PLAYERPIECEPLACEMENT_1_CHK8		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "4", PLAYER SELECTED MINER
	LDA PIECESLEFT+6		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_1_JMP	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #6
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_JMP		;TEMPORARY JUMP POINT, BRANCH DESTINATION OUT OF REACH
	JMP PLAYERPIECEPLACEMENT_END
	
PLAYERPIECEPLACEMENT_1_CHK8
	CMP #$35 				;CHECK IF THE SELECTED OPTION IS "5" (HEX 35)		
	BNE PLAYERPIECEPLACEMENT_1_CHK9		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "5", PLAYER SELECTED MINER
	LDA PIECESLEFT+7		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_END	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #7
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK9
	CMP #$36 				;CHECK IF THE SELECTED OPTION IS "6" (HEX 36)		
	BNE PLAYERPIECEPLACEMENT_1_CHK10		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "6", PLAYER SELECTED MINER
	LDA PIECESLEFT+8		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_END	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #8
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK10
	CMP #$37 				;CHECK IF THE SELECTED OPTION IS "7" (HEX 37)		
	BNE PLAYERPIECEPLACEMENT_1_CHK11		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "7", PLAYER SELECTED MINER
	LDA PIECESLEFT+9		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_END	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #9
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK11
	CMP #$38 				;CHECK IF THE SELECTED OPTION IS "8" (HEX 38)		
	BNE PLAYERPIECEPLACEMENT_1_CHK12		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "8", PLAYER SELECTED MINER
	LDA PIECESLEFT+10		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_END	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #10
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2

PLAYERPIECEPLACEMENT_1_CHK12
	CMP #$39 				;CHECK IF THE SELECTED OPTION IS "9" (HEX 39)		
	BNE PLAYERPIECEPLACEMENT_1_CHK13		;IF IT'S NOT, CHECK THE NEXT OPTION
	;IF IT IS THE CHARACTER "9", PLAYER SELECTED MINER
	LDA PIECESLEFT+11		;LOAD THE AMOUNT OF MINERS LEFT
	CMP #0
	BEQ PLAYERPIECEPLACEMENT_END	;IF THERE'S 0 LEFT, THEN WE CANT PLACE IT, SHOW ERROR MESSAGE AND TRY AGAIN
	LDA #11
	JMP PLAYERPIECEPLACEMENT_2	;IF THERE'S MORE THEN 0 LEFT, JUMP TO PLAYERPIECEPLACEMENT_2
	
PLAYERPIECEPLACEMENT_1_CHK13
	;INVALID SELECTION, SHOW ERROR MESSAGE ON SCREEN
	LDA #<PLACEERR3			;SHOW ERROR ON SCREEN
	STA z_L
	LDA #>PLACEERR3
	STA z_H
	JSR PrintString
	JSR CINPUT				;WAIT FOR PLAYER TO HIT A KEY (WE WONT USE IT)
	RTS						;EXIT SUBROUTINE
	
PLAYERPIECEPLACEMENT_END
	;SELECTED PIECE IS NOT AVAILABLE, SHOW ERROR MESSAGE ON SCREEN
	LDA #<PLACEERR			;SHOW ERROR ON SCREEN
	STA z_L
	LDA #>PLACEERR
	STA z_H
	JSR PrintString
	JSR CINPUT				;WAIT FOR PLAYER TO HIT A KEY (WE WONT USE IT)
	RTS						;EXIT SUBROUTINE

;FROM HERE ON, WE'VE CONCLUDED THE SELECTED LETTER IS A VALID PIECE AND THERE IS AT LEAST 1 PIECE LEFT OF THAT PIECE TO PLACE
PLAYERPIECEPLACEMENT_2
	STA ZPADDR+10			;STORE IN ZPADDR+10 (TEMP LOCATION FOR PIECE TYPE)

	;HERE WE NEED TO CHECK IF THE SELECTED SPOT ON THE PLAYFIELD IS STILL FREE/EMPTY
	STZ ZPADDR+1			;ZERO OUT ZPADDR+1, WE'LL USE THIS AS A LOOP COUNTER
	LDA #$04			
	STA ZPADDR+3			;STORE $04 IN ZPADDR+3, WE'LL USE THIS AS THE HIGH BYTE OF THE SPRITE DATA ARRAY
	LDA #1
	STA ZPADDR+2			;STORE 1 IN ZPADDR+2, WE'LL USE THIS FOR THE LOW BYTE OF THE SPRITE DATA ARRAY (OFFSET BY ONE SO WE GET THE SECOND BYTE OF THE ARRAY)
	
PLAYERPIECEPLACEMENT_2_1
	LDA (ZPADDR+2)			;LOAD THE X AND Y POSITION OF THE PIECE IN THE SPRITE DATA ARRAY
	CMP CURSORACTION1		;COMPARE THIS XY POSITION TO THE XY POSITION WHERE WE WANT TO PLACE THE PIECE DOWN
	BEQ	PLAYERPIECEPLACEMENT_2_1_ERR	;IF IT FINDS A MATCH, THEN THIS XY POSITION IS ALREADY TAKEN
	
	;IF THIS XY POSITION IS NOT TAKEN, WE NEED TO CHECK THE NEXT GAME PIECE
	LDX ZPADDR+1			;LOAD THE LOOP COUNTER
	CPX #79					;SEE IF WE HAVE ALREADY CHECKED ALL 80 GAME PIECES AND THEIR LOCATIONS
	BEQ PLAYERPIECEPLACEMENT_3		;IF WE HAVE, END THE LOOP, AND GO TO PLAYERPIECEPLACEMENT_3, WHERE WE WILL PLACE THE PIECE
	;IF WE HAVENT CHECKED ALL 79 YET, THEN LOOP AGAIN
	INX
	STX ZPADDR+1			;INCREMENT THE PIECE/LOOP COUNTER
	LDA ZPADDR+2			;LOAD THE SPRITE ARRAY LOW BYTE
	CLC
	ADC #3
	STA ZPADDR+2			;ADD 3 TO IT AND STORE IT AGAIN, FOR THE NEXT LOOP
	JMP PLAYERPIECEPLACEMENT_2_1	;AND LOOP AGAIN TO CHECK THE NEXT PIECE

PLAYERPIECEPLACEMENT_2_1_ERR
	;THE SPOT ON THE GAMEFIELD IS NOT FREE, SHOW ERROR AND RETURN
	LDA #<PLACEERR2			;SHOW ERROR ON SCREEN
	STA z_L
	LDA #>PLACEERR2
	STA z_H
	JSR PrintString
	JSR CINPUT				;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	RTS						;EXIT SUBROUTINE

PLAYERPIECEPLACEMENT_3
	;NOW WE KNOW THE POSITION IS FREE, SO PLACE THE PIECE DOWN

	;SO FIRST LETS UPDATE THE PIECES LEFT DATA ARRAY
	LDA #PIECESLEFTH
	STA ZPADDR+1		;LOAD THE HIGH BYTE OF THE PIECES LEFT DATA ARRAY AND STORE IN ZPADDR+1 (HIGH BYTE)
	LDA ZPADDR+10
	
	STA ZPADDR			;LOAD THE SPRITE TYPE IN ZPADDR
	
	LDA (ZPADDR)		;NOW LOAD THE AMOUNT OF PIECES LEFT FROM THE PIECES LEFT DATA ARRAY (OFFSET BY TYPE)
	SEC
	SBC #1				;DECREASE THE AMOUNT BY 1
	STA (ZPADDR)		;AND STORE IT AGAIN WITH IT'S NEW VALUE	
	
	;AND HERE WE WILL ACTUALLY UPDATE DE SPRITE DATA ARRAY AND PLACE THE GAME PIECE DOWN
	LDA ZPADDR+9		;LOAD THE SPRITE NUMBER (ALREADY OFFSET FOR RED/BLUE TEAM)
	LDX ZPADDR+11		;SET X POSITION OF SPRITE
	LDY ZPADDR+12		;SET Y POSITION OF SPRITE
	JSR MOVEPIECE		;SET X AND Y POSITION OF SPRITE THE IN SPRITE DATA ARRAY
	
	LDX ZPADDR+10			;SET PIECE TYPE
	JSR SETPIECETYPE	;SET THE PIECE TYPE IN THE SPRITE DATA ARRAY
	JSR SHOWPIECE		;NOW SHOW/MOVE THE PIECE ON SCREEN
	
;NOW THAT THE PIECE IS PLACED AND THE DATA ARRAY UPDATED, LET'S SEE IF WE NEED TO PLACE MORE PIECES
	LDY VAR_PIECES		;LOAD THE AMOUNT OF PIECES STILL TO PLACE ON THE FIELD
	DEY
	STY VAR_PIECES		;DECEASE BY ONE AND STORE AGAIN
	
	LDY ZPADDR+9
	DEY
	STY ZPADDR+9		;LOAD ZPADDR+9 (SPRITE NUMBER), REDUCE BY 1, AND STORE AGAIN
	
PLAYERPIECEPLACEMENTY
	RTS
	
;---------------------------------------------
;FUNCTION - PHASE 1 CURSOR MOVE WRAPPER
; THIS FUNCTION WILL CATCH ANY KEY PRESSED (OTHER THEN THE CURSOR KEYS) FOR PHASE 1
; AND DECIDE TO RETURN TO PROCESS THE KEY, OR TO RETURN BACK TO THE MOVECURSOR SUBROUTINE
;---------------------------------------------
PHASE1MOVECURSORWRAPPER
	JSR MOVECURSOR		;FIRST MOVE THE CURSOR AROUND UNTIL A KEY OTHER THEN THE CURSOR KEYS IS PRESSED
	
	;THE LAST KEY PRESSED IS IN THE ACCUMULATOR
	CMP #$0D			;CHECK IF THE RETURN KEY HAS BEEN PRESSED
	BNE PHASE1MOVECURSORWRAPPER_0	;IF NOT, JUMP TO THE NEXT ONE
	JMP PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_0
	CMP #$46			;CHECK IF THE 'F' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_1	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_1	
	CMP #$42			;CHECK IF THE 'B' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_2	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION
	
PHASE1MOVECURSORWRAPPER_2	
	CMP #$30			;CHECK IF THE '0' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_3	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_3
	CMP #$31			;CHECK IF THE '1' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_4	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_4
	CMP #$32			;CHECK IF THE '2' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_5	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_5
	CMP #$33			;CHECK IF THE '3' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_6	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_6
	CMP #$34			;CHECK IF THE '4' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_7	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION
	
PHASE1MOVECURSORWRAPPER_7
	CMP #$35			;CHECK IF THE '5' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_8	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_8
	CMP #$36			;CHECK IF THE '6' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_9	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION
	
PHASE1MOVECURSORWRAPPER_9
	CMP #$37			;CHECK IF THE '7' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_A	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_A
	CMP #$38			;CHECK IF THE '8' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_B	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION
	
PHASE1MOVECURSORWRAPPER_B
	CMP #$39			;CHECK IF THE '9' KEY IS PRESSED
	BNE PHASE1MOVECURSORWRAPPER_C	;IF NOT, JUMP TO THE NEXT ONE
	BEQ PHASE1MOVECURSORWRAPPERY	;IF IT IS, KEY ACCEPTED, END FUNCTION

PHASE1MOVECURSORWRAPPER_C
	;NONE OF THE KEYS PRESSED ARE ALLOWED, SO GO BACK TO MOVING THE CURSOR
	JMP PHASE1MOVECURSORWRAPPER
	
PHASE1MOVECURSORWRAPPERY
	STA CHRBUF						;STORE THE CURRENT KEY IN THE CHARACTER BUFFER
	RTS