;----------------------------------------------
;FUNCTION - COMPUTER MOVE, USE RANDOM NUMBER TO TAKE A COMPUTERS PIECE AND MOVE IT OVER THE BOARD
;----------------------------------------------
COMPUTERPHASE3:
	;WE NEED TO FIRST RUN THROUGH ALL THE PIECES OF THE COMPUTER, CHECK IF THE SPRITE IS STILL 'ALIVE' AND IF SO CALCULATE THE 4 MOVES FOR THE PIECE
	;THOSE 4 MOVES HAVE TO BE PUT IN THE COMP_INDIV_SCORES ARRAY.
	;THEN WE HAVE TO CHECK EACH OF THOSE MOVES AND ASSIGN SCORES TO THE MOVES. SO FIRST WE'RE GOING TO ASSIGN SCORES TO 
	; 1) ATTACK BONUS, IF THE MOVE IS ATTACKING, ADD A BONUS TO THE SCORE FOR THE MOVE
	; 2) MOVEMENT BONUS, UP/DOWN/HORIZ MOVEMENT ADD A BONUS TO THE SCORE FOR THE MOVE
	; 3) PIECE TYPE BONUS, ADD THE PIECE TYPE NUMBER TO THE SCORE FOR THE MOVE
	; 4) MARSHALL PENALTY, ADD A PENALTY FOR THE MARSHALL, SO IT'S NOT ALWAYS THE PIECE TO BE MOVED (BECAUSE OF 3)
	; 5) ADD A RANDOM SCORE BETWEEN 0-9 TO ADD SOME UNPREDICABILITY
	
;MOVEMENT SCORE BONUSSES:
DOWN_SCORE			EQU	$03			;ASSIGN A SCORE BONUS OF 3 FOR A DOWNWARDS (FORWARD MOVE)
LEFT_SCORE			EQU $02			;ASSIGN A SCORE BONUS OF 2 FOR A LEFT (X) MOVEMENT
RIGHT_SCORE			EQU $02			;ASSIGN A SCORE BONUS OF 2 FOR A RIGHT (X) MOVEMENT
UP_SCORE			EQU $01			;ASSIGN A SCORE BONUS OF 1 FOR A UPWARDS (BACKWARDS MOVE)
;ATTACKING BONUS:
ATTACK_SCORE		EQU $04			;ASSIGN A SCORE BONUS OF 6 FOR A ATTACKING MOVE
;PIECE TYPE PENALTIES:
MARSHALL_PENALTY	EQU $03			;ASSIGN A SCORE PENALTY OF 5 FOR THE MARSHALL, SO IT'S NOT AS LIKELY THAT IT'S ALWAYS MOVED
;RANDOM VALUE, MAX BONUS
RANDOM_BONUS		EQU $09			;ASSIGN A MAXIMUM SCORE BONUS OF 9 (RANDOM VALUE) 
	
	;CLEAR THE 8 BYTES OF THE COMP_INDIV_SCORES ARRAY
	LDX #0								;LOAD 0 IN X REGISTER (LOOP COUNTER)
COMPUTERPHASE3_0_0L
	STZ COMP_INDIV_SCORES,X				;STORE 0 IN THE COMP_INDIV_SCORES LOCATION, OFFSET BY X
	CPX #7								;CHECK IF WE ALREADY CLEARED 8 BYTES
	BEQ COMPUTERPHASE3_0_0L_DONE		;IF WE DID, EXIT THE LOOP
	INX
	BRA COMPUTERPHASE3_0_0L				;INCREMENT X BY 1 AND LOOP BACK
COMPUTERPHASE3_0_0L_DONE

	;CLEAR THE 120 BYTES OF THE COMP_TOT_SCORES_HIGH ARRAY
	LDA #COMP_TOT_SCORES_HIGH			;LOAD THE HIGH BYTE OF THE COMPUTER TOTAL SCORES ARRAY
	STA ZPADDR+2						;STORE HIGH BYTE IN ZPADDR+2
	LDA #0								;SET A TO 0
	LDX #0								;LOAD 0 IN X REGISTER (LOOP COUNTER)
COMPUTERPHASE3_0_1L
	STX ZPADDR+1						;STORE LOOP COUNTER IN ZPADDR+1 (LOW BYTE)
	STA (ZPADDR+1)						;STORE 0 IN ZPADDR+1 (LOW BYTE), ZPADDR+2 (HIGH BYTE)
	CPX #119							;CHECK IF WE ALREADY CLEARED 120 BYTES
	BEQ COMPUTERPHASE3_0_1L_DONE		;IF WE DID, EXIT THE LOOP
	INX
	BRA COMPUTERPHASE3_0_1L				;INCREMENT X BY 1 AND LOOP BACK
COMPUTERPHASE3_0_1L_DONE	
	
	;FIRST LETS CHECK IF THE COMPUTER IS PLAYING RED OR BLUE, SO WE CAN ADD A OFFSET TO THE 
	LDA VAR_TEAM						;LOAD THE TEAM THE COMPUTER PLAYS AT (1=RED, 0=BLUE)
	CMP #1								;CHECK IF THE COMPUTER I PLAYING THE RED TEAM
	BEQ COMPUTERPHASE3_0_R				;IF IT IS PLAYING RED THEN GOTO COMPUTERPHASE3_0_R
	LDA #40								;LOAD 40 FOR THE OFFSET
	STA COMP_PIECE_OFFSET				;STORE THE OFFSET IN COMP_PIECE_OFFSET (IT'S NOW OFFSET PROPERLY FOR THE BLUE TEAM PIECES).
	BRA COMPUTERPHASE3_1				;BRANCH TO COMPUTERPHASE3_1.
COMPUTERPHASE3_0_R:	
	STZ COMP_PIECE_OFFSET				;STORE 0 IN THE COMP_PIECE OFFSET.

COMPUTERPHASE3_1:						;HERE WE'RE GOING TO RESET THE REGISTERS AND LOOP COUNTERS
	LDA #0								;LOAD 0 FOR THE LOOP COUNTER
	STA ZPADDR+8						;ALSO STORE THE LOOP COUNTER IN ZPADDR+8, THIS WILL BE OUR TOTAL PIECE COUNTER (FOR ALL 40 PIECES)

COMPUTERPHASE3_1_LOOP:					;LOOP POINTER FOR ALL 40 PIECES
	LDA ZPADDR+8						;LOAD THE LOOP COUNTER
	CLC
	ADC COMP_PIECE_OFFSET				;ADD THE OFFSET TO THE LOOPCOUNTER (SO WE LOAD THE RED OF THE BLUE PIECES)
	JSR GETSPRITEDATA					;LOAD THE SPRITE DATA FOR THE PIECE
	
;CHECK IF THE SPRITE IS ALIVE
	LDA ZPADDR+6						;LOAD THE 'DEAD' FLAG FOR THE SPRITE
	CMP #0								;CHECK IF THE SPRITE IS ALIVE
	BNE	COMPUTERPHASE3_1_FINLOOP_JMP	;IF THE SPRITE IS DEAD, THEN WE DONT NEED TO CONTINUE CHECKING IT.
;CHECK IF THE SPRITE IS UNMOVABLE (BOMB OR FLAG)
	LDA ZPADDR+4						;LOAD SPRITE TYPE
	CMP #0								;CHECK IF IT'S A BOMB
	BEQ	COMPUTERPHASE3_1_FINLOOP_JMP	;IF IT IS A BOMB, END CHECKING THIS SPRITE
	CMP #1								;CHECK IF IT'S A FLAG
	BEQ	COMPUTERPHASE3_1_FINLOOP_JMP	;IF IT IS A FLAG, END CHECKING THIS SPRITE
	
	
;NOW WE'RE GOING TO CALCULATE THE 4 MOVES OF THIS PIECE
;**************************************************************
;START WITH THE UPWARDS MOVEMENT CHECKS
	STZ COMP_TMPSCORE					;RESET THE COMPTMPSCORE VAR SO IT CAN BE USED AGAIN
	LDA ZPADDR+2						;LOAD X POSITION OF THE PIECE
	TAX									;TRANSFER X POSITION FROM A TO X REGISTER (FOR GETSPRITENUMBER LATER)
	ASL									;BITSHIFT TO THE LEFT (000XXXX0)
	ASL									;BITSHIFT TO THE LEFT (00XXXX00)
	ASL									;BITSHIFT TO THE LEFT (0XXXX000)
	ASL									;BITSHIFT TO THE LEFT (XXXX0000)
	STA ZPADDR+9						;STORE POSITION IN ZPADDR+9 FOR NOW
	LDA ZPADDR+3						;LOAD Y POSITION
	CLC
	ADC ZPADDR+9						;ADD X TO THE Y POSITION (XXXXYYYYY)
	STA ZPADDR+9						;STORE THE XY POS IN ZPADDR+9 AGAIN
	
	;SUBTRACT ONE FROM THE Y POSITION (CHECK UPWARDS)
	SEC
	SBC	#1								;SUBTRACT ONE FROM THE XY POSITION, EFFECTIVLY SUBTRACT ONE FROM Y
	STA ZPADDR+10						;STORE THE UPPOS TO ZPADDR+10
	AND #%00001111						;APPLY BITMASK SO ONLY THE NEW Y POSITION IS LEFT
	TAY									;TRANSFER Y POSITION FROM A TO Y REGISTER (FOR GETSPRITENUMBER LATER)
	;FIRST WE NEED TO CHECK IF THERE'S ANOTHER SPRITE AT THIS POS
	JSR GETSPRITENUMBER					;A CONTAINS XY POSITION, TRY TO FIND A PIECE, USING X AND Y REGISTERS AS X AND Y POS
	CMP #255							;CHECK IF THE RETURNED SPRITE NUMBER IS 255 (NOTHING FOUND)
	BEQ COMPUTERPHASE3_2_EMPTY			;IF IT IS EMPTY, GO DO CHECKS ON EMTPTY FIELDS
	;IF IT CONTAINS A SPRITE, WE NEED TO CHECK IF IT'S ONE OF THE COMPUTER'S OWN PIECES	
	STA ZPADDR+11						;STORE THE SPRITE NUMBER OF UPWARDS XY POS IN ZPADDR+11 FOR NOW	
	LDA VAR_TEAM						;LOAD THE TEAM NUMBER
	CMP #0								;CHECK IF THE COMPUTER IS THE BLUE TEAM
	BEQ COMPUTERPHASE3_2_1B				;IF THE COMPUTER DOES PLAY THE BLUE TEAM, GO THERE
	;IF THE COMPUTER IS PLAYING THE RED TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE UPWARDS XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCC	COMPUTERPHASE3_3				;IF THE SPRITE IS A RED TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A BLUE TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
	BRA COMPUTERPHASE3_2_1_DONE			

COMPUTERPHASE3_1_FINLOOP_JMP:			;INTERMEDIARY JUMP POINT, BRANCH IS OUT OF RANGE
	JMP COMPUTERPHASE3_1_FINLOOP
	
COMPUTERPHASE3_2_1B: 					;IF THE COMPUTER IS PLAYING THE BLUE TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE UPWARDS XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCS	COMPUTERPHASE3_3				;IF THE SPRITE IS A BLUE TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A RED TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
COMPUTERPHASE3_2_1_DONE
	LDA #ATTACK_SCORE					;LOAD THE ATTACK BONUS 
	STA COMP_TMPSCORE					;STORE THE SCORE IN THE COMP_TMPSCORE REGISTER FOR NOW
	BRA COMPUTERPHASE3_2_2				;NOW THAT WE DONE CHECKING WHAT'S AT THE UPWARDS XY POS, GO TO THE NEXT PART
	
COMPUTERPHASE3_2_EMPTY:					;THE XYUP POSITION IS EMPTY
	;FIRST WE NEED TO CHECK IF THE POSITION IS OUTSIDE THE PLAYFIELD
	LDA ZPADDR+10						;LOAD UPWARDS XY POSITION IN A	
	AND #%00001111						;APPLY BITMASK, LEAVING ONLY THE Y POSITION
	CMP #15								;COMPARE THE Y POSITION TO 15 (OR -1), JUST ABOVE THE PLAYFIELD
	BEQ COMPUTERPHASE3_3				;IF IT IS, THIS MOVEMENT IS OUT SIDE OF THE PLAYFIELD, GO CHECK DOWNWARDS MOVEMENT
	;NOW WE NEED TO CHECK IF THE POSITION IS NOT IN ASIDE THE 2 OBSTACLES IN THE MIDDLE OF THE GAMEBOARD
	;WE CHECK THE INVALIDPOS LOOKUP TABLE FOR THAT
	LDY #0								;EMPTY Y AS LOOPCOUNTER
COMPUTERPHASE3_2_EMPTY_L:
	LDA INVALIDPOS,Y					;LOAD THE VALUE FROM THE INVALIDPOS LOOKUP TABLE
	CMP ZPADDR+10						;CHECK THE VALUE FROM THE INVALIDPOS LOOKUP TABLE TO THE XY POSITION OF THE XY UP POSITION
	BEQ COMPUTERPHASE3_3				;IF A MATCH HAS BEEN FOUND, THEN THE XY UP POSITION IS INVALID! CHECK DOWNWARDS XY POSITION
	CPY #7								;CHECK IF WE'VE ALREADY CHECKED ALL 7 POSITIONS IN THE INVALIDPOS LOOKUP TABLE
	BEQ COMPUTERPHASE3_2_2				;IF WE DID, THEN END THE LOOP
	INY									;INCREMENT Y
	BRA COMPUTERPHASE3_2_EMPTY_L		;JUMP BACK TO THE LOOP

COMPUTERPHASE3_2_2:						;NOW THAT WE DONE CHECKING -WHAT'S AT- THE UPWARDS XY POS, ON WITH THE MOVEMENT BONUS
	;NOW THAT WE KNOW THAT THE POSITION IS EMPTY, INSIDE THE GAME BOARD AND NOT INSIDE THE 2 OBSTACLES, WE CAN ADD THE UPWARDS BONUS TO THE SCORE
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	CLC
	ADC #UP_SCORE						;ADD THE UPWARDS MOVE BONUS TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
	;NOW THAT THE ATTACK BONUS AND MOVEMENT BONUS HAVE BEEN ADDED, NOW LET'S ADD THE PIECE TYPE BONUS
	LDA ZPADDR							;LOAD THE SPRITE NUMBER IF THE PIECE TO MOVE
	JSR GETSPRITEDATA					;GET THE SPRITE DATA AGAIN (AS THE GETSPRITENUMBER SUB BROKE ZPADDR+4, WE NEED TO GET THE PIECE TYPE AGAIN)
	LDA COMP_TMPSCORE					;LOAD THE TMP SCORE IN A
	CLC
	ADC ZPADDR+4						;ADD THE PIECE TYPE NUMBER TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	;NOW CHECK IF THE PIECE TYPE IS  A MARSHALL, SO WE CAN SUBTRACT THE PENALTY
	LDA ZPADDR+4						;LOAD THE PIECE TYPE
	CMP #11								;CHECK IF THE PIECE TYPE IS THE MARSHALL
	BNE COMPUTERPHASE3_2_3				;IF IT'S NOT, THEN NO PENALTY, MOVING ON!
	;OTHERWISE WE APPLY THE MARSHALL PENALTY
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	SEC
	SBC #MARSHALL_PENALTY				;SUBTRACT THE MARSHALL PENALTY FROM THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
COMPUTERPHASE3_2_3:
	;NOW ADD A RANDOM VALUE TO ADD SOME UNPREDICABILITY TO THE COMPUTERS MOVES
	LDA #RANDOM_BONUS				
	JSR RAND							;GET RANDOM VALUE BETWEEN 0 AND 19.
	STA ZPADDR+12						;STORE RANDOM VALUE IN ZPADDR+12
	LDA COMP_TMPSCORE					;LOAD THE MOVE'S SCORE
	CLC
	ADC ZPADDR+12						;ADD THE RANDOM VALUE TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE SCORE AGAIN
						
	;NOW THAT ALL THE SCORES AND PENALTIES ARE ADDED, LETS STORE THE INFORMATION IN THE COMP_INDIV_SCORES ARRAY
	LDA COMP_TMPSCORE
	STA COMP_INDIV_SCORES				;STORE THE UPWARDS MOVE SCORE IN COMP_INDIV_SCORES
	LDA ZPADDR+10						
	STA COMP_INDIV_SCORES+1				;LOAD THE UPWARDS MOVE XY POSITION IN COMP_INDIV_SCORES+1
	
;**************************************************************
;NEXT MOVE, WE CHECK THE DOWNWARDS MOVEMENT FOR THIS GAMEPIECE
COMPUTERPHASE3_3:
	STZ COMP_TMPSCORE					;RESET THE COMPTMPSCORE VAR SO IT CAN BE USED AGAIN
	LDA ZPADDR+8						;LOAD THE LOOP COUNTER
	CLC
	ADC COMP_PIECE_OFFSET				;ADD THE OFFSET TO THE LOOPCOUNTER (SO WE LOAD THE RED OF THE BLUE PIECES)
	JSR GETSPRITEDATA					;LOAD THE SPRITE DATA FOR THE PIECE

	LDA ZPADDR+2						;LOAD X POSITION OF THE PIECE
	TAX									;TRANSFER X POSITION FROM A TO X REGISTER (FOR GETSPRITENUMBER LATER)
	ASL									;BITSHIFT TO THE LEFT (000XXXX0)
	ASL									;BITSHIFT TO THE LEFT (00XXXX00)
	ASL									;BITSHIFT TO THE LEFT (0XXXX000)
	ASL									;BITSHIFT TO THE LEFT (XXXX0000)
	STA ZPADDR+9						;STORE POSITION IN ZPADDR+9 FOR NOW
	LDA ZPADDR+3						;LOAD Y POSITION
	CLC
	ADC ZPADDR+9						;ADD X TO THE Y POSITION (XXXXYYYYY)
	STA ZPADDR+9						;STORE THE XY POS IN ZPADDR+9 AGAIN
	
	;ADD ONE FROM THE Y POSITION (CHECK DOWNWARDS)
	CLC
	ADC	#1								;ADD ONE TO THE XY POSITION, EFFECTIVLY ADD ONE TO Y
	STA ZPADDR+10						;STORE THE DOWNPOS TO ZPADDR+10
	AND #%00001111						;APPLY BITMASK SO ONLY THE NEW Y POSITION IS LEFT
	TAY									;TRANSFER Y POSITION FROM A TO Y REGISTER (FOR GETSPRITENUMBER LATER)
	;FIRST WE NEED TO CHECK IF THERE'S ANOTHER SPRITE AT THIS POS
	JSR GETSPRITENUMBER					;A CONTAINS XY POSITION, TRY TO FIND A PIECE, USING X AND Y REGISTERS AS X AND Y POS
	CMP #255							;CHECK IF THE RETURNED SPRITE NUMBER IS 255 (NOTHING FOUND)
	BEQ COMPUTERPHASE3_3_EMPTY			;IF IT IS EMPTY, GO DO CHECKS ON EMTPTY FIELDS
	;IF IT CONTAINS A SPRITE, WE NEED TO CHECK IF IT'S ONE OF THE COMPUTER'S OWN PIECES	
	STA ZPADDR+11						;STORE THE SPRITE NUMBER OF DOWNWARDS XY POS IN ZPADDR+11 FOR NOW	
	
	LDA VAR_TEAM						;LOAD THE TEAM NUMBER
	CMP #0								;CHECK IF THE COMPUTER IS THE BLUE TEAM
	BEQ COMPUTERPHASE3_3_1B				;IF THE COMPUTER DOES PLAY THE BLUE TEAM, GO THERE
	;IF THE COMPUTER IS PLAYING THE RED TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE DOWNWARDS XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCC	COMPUTERPHASE3_4				;IF THE SPRITE IS A RED TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A BLUE TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
	BRA COMPUTERPHASE3_3_1_DONE			
	
COMPUTERPHASE3_3_1B: 					;IF THE COMPUTER IS PLAYING THE BLUE TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE DOWNWARDS XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCS	COMPUTERPHASE3_4				;IF THE SPRITE IS A BLUE TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A RED TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
COMPUTERPHASE3_3_1_DONE
	LDA #ATTACK_SCORE					;LOAD THE ATTACK BONUS 
	STA COMP_TMPSCORE					;STORE THE SCORE IN THE COMP_TMPSCORE REGISTER FOR NOW
	BRA COMPUTERPHASE3_3_2				;NOW THAT WE DONE CHECKING WHAT'S AT THE DOWNWARDS XY POS, GO TO THE NEXT PART
	
COMPUTERPHASE3_3_EMPTY:					;THE XYDOWN POSITION IS EMPTY
	;FIRST WE NEED TO CHECK IF THE POSITION IS OUTSIDE THE PLAYFIELD
	LDA ZPADDR+10						;LOAD DOWNWARDS XY POSITION IN A	
	AND #%00001111						;APPLY BITMASK, LEAVING ONLY THE Y POSITION
	CMP #10								;COMPARE THE Y POSITION TO 10 , JUST TO THE RIGHT OUTSIDE THE PLAYFIELD
	BEQ COMPUTERPHASE3_4				;IF IT IS, THIS MOVEMENT IS OUT SIDE OF THE PLAYFIELD, GO CHECK LEFT MOVEMENT
	;NOW WE NEED TO CHECK IF THE POSITION IS NOT IN ASIDE THE 2 OBSTACLES IN THE MIDDLE OF THE GAMEBOARD
	;WE CHECK THE INVALIDPOS LOOKUP TABLE FOR THAT
	LDY #0								;EMPTY Y AS LOOPCOUNTER
COMPUTERPHASE3_3_EMPTY_L:
	LDA INVALIDPOS,Y					;LOAD THE VALUE FROM THE INVALIDPOS LOOKUP TABLE
	CMP ZPADDR+10						;CHECK THE VALUE FROM THE INVALIDPOS LOOKUP TABLE TO THE XY POSITION OF THE XY DOWN POSITION
	BEQ COMPUTERPHASE3_4				;IF A MATCH HAS BEEN FOUND, THEN THE XY DOWN POSITION IS INVALID! CHECK LEFT XY POSITION
	CPY #7								;CHECK IF WE'VE ALREADY CHECKED ALL 7 POSITIONS IN THE INVALIDPOS LOOKUP TABLE
	BEQ COMPUTERPHASE3_3_2				;IF WE DID, THEN END THE LOOP
	INY									;INCREMENT Y
	BRA COMPUTERPHASE3_3_EMPTY_L		;JUMP BACK TO THE LOOP
	
COMPUTERPHASE3_3_2:						;NOW THAT WE DONE CHECKING -WHAT'S AT- THE DOWNWARDS XY POS, ON WITH THE MOVEMENT BONUS	
	;NOW THAT WE KNOW THAT THE POSITION IS EMPTY, INSIDE THE GAME BOARD AND NOT INSIDE THE 2 OBSTACLES, WE CAN ADD THE DOWNWARDS BONUS TO THE SCORE
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	CLC
	ADC #DOWN_SCORE						;ADD THE DOWNWARDS MOVE BONUS TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
	;NOW THAT THE ATTACK BONUS AND MOVEMENT BONUS HAVE BEEN ADDED, NOW LET'S ADD THE PIECE TYPE BONUS
	LDA ZPADDR							;LOAD THE SPRITE NUMBER IF THE PIECE TO MOVE
	JSR GETSPRITEDATA					;GET THE SPRITE DATA AGAIN (AS THE GETSPRITENUMBER SUB BROKE ZPADDR+4, WE NEED TO GET THE PIECE TYPE AGAIN)
	LDA COMP_TMPSCORE					;LOAD THE TMP SCORE IN A
	CLC
	ADC ZPADDR+4						;ADD THE PIECE TYPE NUMBER TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	;NOW CHECK IF THE PIECE TYPE IS  A MARSHALL, SO WE CAN SUBTRACT THE PENALTY
	LDA ZPADDR+4						;LOAD THE PIECE TYPE
	CMP #11								;CHECK IF THE PIECE TYPE IS THE MARSHALL
	BNE COMPUTERPHASE3_3_3				;IF IT'S NOT, THEN NO PENALTY, MOVING ON!
	;OTHERWISE WE APPLY THE MARSHALL PENALTY
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	SEC
	SBC #MARSHALL_PENALTY				;SUBTRACT THE MARSHALL PENALTY FROM THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
COMPUTERPHASE3_3_3:	
	;NOW ADD A RANDOM VALUE TO ADD SOME UNPREDICABILITY TO THE COMPUTERS MOVES
	LDA #RANDOM_BONUS				
	JSR RAND							;GET RANDOM VALUE BETWEEN 0 AND 19.
	STA ZPADDR+12						;STORE RANDOM VALUE IN ZPADDR+12
	LDA COMP_TMPSCORE					;LOAD THE MOVE'S SCORE
	CLC
	ADC ZPADDR+12						;ADD THE RANDOM VALUE TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE SCORE AGAIN
	
	;NOW THAT ALL THE SCORES AND PENALTIES ARE ADDED, LETS STORE THE INFORMATION IN THE COMP_INDIV_SCORES ARRAY
	LDA COMP_TMPSCORE
	STA COMP_INDIV_SCORES+2				;STORE THE MOVE SCORE IN COMP_INDIV_SCORES+2
	LDA ZPADDR+10						
	STA COMP_INDIV_SCORES+3				;LOAD THE MOVE XY POSITION IN COMP_INDIV_SCORES+3
	
	
;**************************************************************
;NEXT MOVE, WE CHECK THE LEFT MOVEMENT FOR THIS GAMEPIECE
COMPUTERPHASE3_4:	
	STZ COMP_TMPSCORE					;RESET THE COMPTMPSCORE VAR SO IT CAN BE USED AGAIN
	LDA ZPADDR+8						;LOAD THE LOOP COUNTER
	CLC
	ADC COMP_PIECE_OFFSET				;ADD THE OFFSET TO THE LOOPCOUNTER (SO WE LOAD THE RED OF THE BLUE PIECES)
	JSR GETSPRITEDATA					;LOAD THE SPRITE DATA FOR THE PIECE

	LDA ZPADDR+2						;LOAD X POSITION OF THE PIECE
	
	SEC
	SBC #1								;SUBTRACT 1 FROM THE X POSITION
	TAX									;TRANSFER X POSITION FROM A TO X REGISTER (FOR GETSPRITENUMBER LATER)
	CLC
	ADC	#1								;AND ADD 1 TO THE X POSITION AGAIN, SETTING IT BACK TO IT'S ORIGINAL POSITION
	
	ASL									;BITSHIFT TO THE LEFT (000XXXX0)
	ASL									;BITSHIFT TO THE LEFT (00XXXX00)
	ASL									;BITSHIFT TO THE LEFT (0XXXX000)
	ASL									;BITSHIFT TO THE LEFT (XXXX0000)
	STA ZPADDR+9						;STORE POSITION IN ZPADDR+9 FOR NOW
	LDA ZPADDR+3						;LOAD Y POSITION OF SPRITE
	TAY									;TRANSFER Y POSITION FROM A TO Y REGISTER (FOR GETSPRITENUMBER LATER)
	CLC
	ADC ZPADDR+9						;ADD X TO THE Y POSITION (XXXXYYYYY)
	STA ZPADDR+9						;STORE THE XY POS IN ZPADDR+9 AGAIN
	
	;SUBTRACT ONE FROM THE X POSITION (CHECK LEFT)
	SEC
	SBC	#16								;SUBTRACT 16 FROM THE XY POSITION, EFFECTIVLY SUBTRACT ONE FROM X
	STA ZPADDR+10						;STORE THE LEFTPOS TO ZPADDR+10
	
	;FIRST WE NEED TO CHECK IF THERE'S ANOTHER SPRITE AT THIS POS
	JSR GETSPRITENUMBER					;A CONTAINS XY POSITION, TRY TO FIND A PIECE, USING X AND Y REGISTERS AS X AND Y POS
	CMP #255							;CHECK IF THE RETURNED SPRITE NUMBER IS 255 (NOTHING FOUND)
	BEQ COMPUTERPHASE3_4_EMPTY			;IF IT IS EMPTY, GO DO CHECKS ON EMTPTY FIELDS
	;IF IT CONTAINS A SPRITE, WE NEED TO CHECK IF IT'S ONE OF THE COMPUTER'S OWN PIECES	
	STA ZPADDR+11						;STORE THE SPRITE NUMBER OF LEFT XY POS IN ZPADDR+11 FOR NOW	
	
	LDA VAR_TEAM						;LOAD THE TEAM NUMBER
	CMP #0								;CHECK IF THE COMPUTER IS THE BLUE TEAM
	BEQ COMPUTERPHASE3_4_1B				;IF THE COMPUTER DOES PLAY THE BLUE TEAM, GO THERE
	;IF THE COMPUTER IS PLAYING THE RED TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE LEFT XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCC	COMPUTERPHASE3_5				;IF THE SPRITE IS A RED TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A BLUE TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
	BRA COMPUTERPHASE3_4_1_DONE			

COMPUTERPHASE3_4_1B: 					;IF THE COMPUTER IS PLAYING THE BLUE TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE LEFT XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCS	COMPUTERPHASE3_5				;IF THE SPRITE IS A BLUE TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A RED TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
COMPUTERPHASE3_4_1_DONE
	LDA #ATTACK_SCORE					;LOAD THE ATTACK BONUS 
	STA COMP_TMPSCORE					;STORE THE SCORE IN THE COMP_TMPSCORE REGISTER FOR NOW
	BRA COMPUTERPHASE3_4_2				;NOW THAT WE DONE CHECKING WHAT'S AT THE LEFT XY POS, GO TO THE NEXT PART
	
COMPUTERPHASE3_4_EMPTY:					;THE XY LEFT POSITION IS EMPTY
	;FIRST WE NEED TO CHECK IF THE POSITION IS OUTSIDE THE PLAYFIELD	
	LDA ZPADDR+10						;LOAD LEFT XY POSITION IN A	
	AND #%11110000						;APPLY BITMASK, LEAVING ONLY THE X POSITION
	LSR									;BITSHIFT TO THE RIGHT (0XXXX000)
	LSR									;BITSHIFT TO THE RIGHT (00XXXX00)
	LSR									;BITSHIFT TO THE RIGHT (000XXXX0)
	LSR									;BITSHIFT TO THE RIGHT (0000XXXX)
	CMP #15								;COMPARE THE X POSITION TO 15 (OR -1), JUST TO THE LEFT THE PLAYFIELD
	BEQ COMPUTERPHASE3_5				;IF IT IS, THIS MOVEMENT IS OUT SIDE OF THE PLAYFIELD, GO CHECK LEFT MOVEMENT
	;NOW WE NEED TO CHECK IF THE POSITION IS NOT IN ASIDE THE 2 OBSTACLES IN THE MIDDLE OF THE GAMEBOARD
	;WE CHECK THE INVALIDPOS LOOKUP TABLE FOR THAT
	LDY #0								;EMPTY Y AS LOOPCOUNTER
COMPUTERPHASE3_4_EMPTY_L:
	LDA INVALIDPOS,Y					;LOAD THE VALUE FROM THE INVALIDPOS LOOKUP TABLE
	CMP ZPADDR+10						;CHECK THE VALUE FROM THE INVALIDPOS LOOKUP TABLE TO THE XY POSITION OF THE XY LEFT POSITION
	BEQ COMPUTERPHASE3_5				;IF A MATCH HAS BEEN FOUND, THEN THE XY LEFT POSITION IS INVALID! CHECK LEFT XY POSITION
	CPY #7								;CHECK IF WE'VE ALREADY CHECKED ALL 7 POSITIONS IN THE INVALIDPOS LOOKUP TABLE
	BEQ COMPUTERPHASE3_4_2				;IF WE DID, THEN END THE LOOP
	INY									;INCREMENT Y
	BRA COMPUTERPHASE3_4_EMPTY_L		;JUMP BACK TO THE LOOP

COMPUTERPHASE3_4_2:						;NOW THAT WE DONE CHECKING -WHAT'S AT- THE LEFT XY POS, ON WITH THE MOVEMENT BONUS	
	;NOW THAT WE KNOW THAT THE POSITION IS EMPTY, INSIDE THE GAME BOARD AND NOT INSIDE THE 2 OBSTACLES, WE CAN ADD THE LEFT BONUS TO THE SCORE
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	CLC
	ADC #LEFT_SCORE						;ADD THE LEFT MOVE BONUS TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
	;NOW THAT THE ATTACK BONUS AND MOVEMENT BONUS HAVE BEEN ADDED, NOW LET'S ADD THE PIECE TYPE BONUS
	LDA ZPADDR							;LOAD THE SPRITE NUMBER IF THE PIECE TO MOVE
	JSR GETSPRITEDATA					;GET THE SPRITE DATA AGAIN (AS THE GETSPRITENUMBER SUB BROKE ZPADDR+4, WE NEED TO GET THE PIECE TYPE AGAIN)
	LDA COMP_TMPSCORE					;LOAD THE TMP SCORE IN A
	CLC
	ADC ZPADDR+4						;ADD THE PIECE TYPE NUMBER TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	;NOW CHECK IF THE PIECE TYPE IS  A MARSHALL, SO WE CAN SUBTRACT THE PENALTY
	LDA ZPADDR+4						;LOAD THE PIECE TYPE
	CMP #11								;CHECK IF THE PIECE TYPE IS THE MARSHALL
	BNE COMPUTERPHASE3_4_3				;IF IT'S NOT, THEN NO PENALTY, MOVING ON!
	;OTHERWISE WE APPLY THE MARSHALL PENALTY
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	SEC
	SBC #MARSHALL_PENALTY				;SUBTRACT THE MARSHALL PENALTY FROM THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
COMPUTERPHASE3_4_3:			
	;NOW ADD A RANDOM VALUE TO ADD SOME UNPREDICABILITY TO THE COMPUTERS MOVES
	LDA #RANDOM_BONUS				
	JSR RAND							;GET RANDOM VALUE BETWEEN 0 AND 19.
	STA ZPADDR+12						;STORE RANDOM VALUE IN ZPADDR+12
	LDA COMP_TMPSCORE					;LOAD THE MOVE'S SCORE
	CLC
	ADC ZPADDR+12						;ADD THE RANDOM VALUE TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE SCORE AGAIN
			
	;NOW THAT ALL THE SCORES AND PENALTIES ARE ADDED, LETS STORE THE INFORMATION IN THE COMP_INDIV_SCORES ARRAY
	LDA COMP_TMPSCORE
	STA COMP_INDIV_SCORES+4				;STORE THE MOVE SCORE IN COMP_INDIV_SCORES+4
	LDA ZPADDR+10						
	STA COMP_INDIV_SCORES+5				;LOAD THE MOVE XY POSITION IN COMP_INDIV_SCORES+5

	
;**************************************************************
;NEXT MOVE, WE CHECK THE RIGHT MOVEMENT FOR THIS GAMEPIECE
COMPUTERPHASE3_5:	
	STZ COMP_TMPSCORE					;RESET THE COMPTMPSCORE VAR SO IT CAN BE USED AGAIN
	LDA ZPADDR+8						;LOAD THE LOOP COUNTER
	CLC
	ADC COMP_PIECE_OFFSET				;ADD THE OFFSET TO THE LOOPCOUNTER (SO WE LOAD THE RED OF THE BLUE PIECES)
	JSR GETSPRITEDATA					;LOAD THE SPRITE DATA FOR THE PIECE

	LDA ZPADDR+2						;LOAD X POSITION OF THE PIECE
	
	CLC
	ADC #1								;ADD 1 TO THE X POSITION
	TAX									;TRANSFER X POSITION FROM A TO X REGISTER (FOR GETSPRITENUMBER LATER)
	SEC
	SBC	#1								;AND SUBTRACT 1 FROM THE X POSITION AGAIN, SETTING IT BACK TO IT'S ORIGINAL POSITION
	
	ASL									;BITSHIFT TO THE LEFT (000XXXX0)
	ASL									;BITSHIFT TO THE LEFT (00XXXX00)
	ASL									;BITSHIFT TO THE LEFT (0XXXX000)
	ASL									;BITSHIFT TO THE LEFT (XXXX0000)
	STA ZPADDR+9						;STORE POSITION IN ZPADDR+9 FOR NOW
	LDA ZPADDR+3						;LOAD Y POSITION OF SPRITE
	TAY									;TRANSFER Y POSITION FROM A TO Y REGISTER (FOR GETSPRITENUMBER LATER)
	CLC
	ADC ZPADDR+9						;ADD X TO THE Y POSITION (XXXXYYYYY)
	STA ZPADDR+9						;STORE THE XY POS IN ZPADDR+9 AGAIN
	
	;ADD 16 TO THE X POSITION (CHECK RIGHT)
	CLC
	ADC	#16								;ADD 16 TO THE XY POSITION, EFFECTIVLY ADD ONE TO X
	STA ZPADDR+10						;STORE THE LEFTPOS TO ZPADDR+10
	
	;FIRST WE NEED TO CHECK IF THERE'S ANOTHER SPRITE AT THIS POS
	JSR GETSPRITENUMBER					;A CONTAINS XY POSITION, TRY TO FIND A PIECE, USING X AND Y REGISTERS AS X AND Y POS
	CMP #255							;CHECK IF THE RETURNED SPRITE NUMBER IS 255 (NOTHING FOUND)
	BEQ COMPUTERPHASE3_5_EMPTY			;IF IT IS EMPTY, GO DO CHECKS ON EMTPTY FIELDS
	;IF IT CONTAINS A SPRITE, WE NEED TO CHECK IF IT'S ONE OF THE COMPUTER'S OWN PIECES	
	STA ZPADDR+11						;STORE THE SPRITE NUMBER OF RIGHT XY POS IN ZPADDR+11 FOR NOW	
	
	LDA VAR_TEAM						;LOAD THE TEAM NUMBER
	CMP #0								;CHECK IF THE COMPUTER IS THE BLUE TEAM
	BEQ COMPUTERPHASE3_5_1B				;IF THE COMPUTER DOES PLAY THE BLUE TEAM, GO THERE
	;IF THE COMPUTER IS PLAYING THE RED TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE RIGHT XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCC	COMPUTERPHASE3_1_CALC_BESTMOVE	;IF THE SPRITE IS A RED TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A BLUE TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
	BRA COMPUTERPHASE3_5_1_DONE			
	
COMPUTERPHASE3_5_1B: 					;IF THE COMPUTER IS PLAYING THE BLUE TEAM, CHECK IF THE RETURNED SPRITE NUMBER IS ONE OF HIS
	LDA ZPADDR+11						;LOAD THE SPRITE NUMBER FOR THE RIGHT XY POSITION
	CMP #40								;CHECK IF THE SPRITE NUMBER IS 40
	BCS	COMPUTERPHASE3_1_CALC_BESTMOVE	;IF THE SPRITE IS A BLUE TEAM SPRITE, THEN IT'S A COMPUTER'S SPRITE, THUS NOT A VALID MOVE, END!
	;IF IT'S NOT, THEN IT'S A RED TEAM SPRITE, THUS WE CAN ATTACK THIS PIECE, ADD A ATTACK BONUS!
COMPUTERPHASE3_5_1_DONE
	LDA #ATTACK_SCORE					;LOAD THE ATTACK BONUS 
	STA COMP_TMPSCORE					;STORE THE SCORE IN THE COMP_TMPSCORE REGISTER FOR NOW
	BRA COMPUTERPHASE3_5_2				;NOW THAT WE DONE CHECKING WHAT'S AT THE RIGHT XY POS, GO TO THE NEXT PART
	
COMPUTERPHASE3_5_EMPTY:					;THE XY RIGHT POSITION IS EMPTY
	;FIRST WE NEED TO CHECK IF THE POSITION IS OUTSIDE THE PLAYFIELD	
	LDA ZPADDR+10						;LOAD RIGHT XY POSITION IN A	
	AND #%11110000						;APPLY BITMASK, LEAVING ONLY THE X POSITION
	LSR									;BITSHIFT TO THE RIGHT (0XXXX000)
	LSR									;BITSHIFT TO THE RIGHT (00XXXX00)
	LSR									;BITSHIFT TO THE RIGHT (000XXXX0)
	LSR									;BITSHIFT TO THE RIGHT (0000XXXX)
	CMP #10								;COMPARE THE X POSITION TO 10, JUST TO THE RIGHT THE PLAYFIELD
	BEQ COMPUTERPHASE3_1_CALC_BESTMOVE	;IF IT IS, THIS MOVEMENT IS OUT SIDE OF THE PLAYFIELD, MOVING ON!
	;NOW WE NEED TO CHECK IF THE POSITION IS NOT IN ASIDE THE 2 OBSTACLES IN THE MIDDLE OF THE GAMEBOARD
	;WE CHECK THE INVALIDPOS LOOKUP TABLE FOR THAT
	LDY #0								;EMPTY Y AS LOOPCOUNTER
COMPUTERPHASE3_5_EMPTY_L:
	LDA INVALIDPOS,Y					;LOAD THE VALUE FROM THE INVALIDPOS LOOKUP TABLE
	CMP ZPADDR+10						;CHECK THE VALUE FROM THE INVALIDPOS LOOKUP TABLE TO THE XY POSITION OF THE XY RIGHT POSITION
	BEQ COMPUTERPHASE3_1_CALC_BESTMOVE	;IF A MATCH HAS BEEN FOUND, THEN THE XY RIGHT POSITION IS INVALID! MOVING ON
	CPY #7								;CHECK IF WE'VE ALREADY CHECKED ALL 7 POSITIONS IN THE INVALIDPOS LOOKUP TABLE
	BEQ COMPUTERPHASE3_5_2				;IF WE DID, THEN END THE LOOP
	INY									;INCREMENT Y
	BRA COMPUTERPHASE3_5_EMPTY_L		;JUMP BACK TO THE LOOP
	
COMPUTERPHASE3_5_2:						;NOW THAT WE DONE CHECKING -WHAT'S AT- THE RIGHT XY POS, ON WITH THE MOVEMENT BONUS	
	;NOW THAT WE KNOW THAT THE POSITION IS EMPTY, INSIDE THE GAME BOARD AND NOT INSIDE THE 2 OBSTACLES, WE CAN ADD THE LEFT BONUS TO THE SCORE
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	CLC
	ADC #RIGHT_SCORE					;ADD THE RIGHT MOVE BONUS TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
	;NOW THAT THE ATTACK BONUS AND MOVEMENT BONUS HAVE BEEN ADDED, NOW LET'S ADD THE PIECE TYPE BONUS
	LDA ZPADDR							;LOAD THE SPRITE NUMBER IF THE PIECE TO MOVE
	JSR GETSPRITEDATA					;GET THE SPRITE DATA AGAIN (AS THE GETSPRITENUMBER SUB BROKE ZPADDR+4, WE NEED TO GET THE PIECE TYPE AGAIN)
	LDA COMP_TMPSCORE					;LOAD THE TMP SCORE IN A
	CLC
	ADC ZPADDR+4						;ADD THE PIECE TYPE NUMBER TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	;NOW CHECK IF THE PIECE TYPE IS  A MARSHALL, SO WE CAN SUBTRACT THE PENALTY
	LDA ZPADDR+4						;LOAD THE PIECE TYPE
	CMP #11								;CHECK IF THE PIECE TYPE IS THE MARSHALL
	BNE COMPUTERPHASE3_5_3				;IF IT'S NOT, THEN NO PENALTY, MOVING ON!
	;OTHERWISE WE APPLY THE MARSHALL PENALTY
	LDA COMP_TMPSCORE					;LOAD THE TMPSCORE
	SEC
	SBC #MARSHALL_PENALTY				;SUBTRACT THE MARSHALL PENALTY FROM THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE COMP_TMPSCORE AGAIN
	
COMPUTERPHASE3_5_3:	
	;NOW ADD A RANDOM VALUE TO ADD SOME UNPREDICABILITY TO THE COMPUTERS MOVES
	LDA #RANDOM_BONUS				
	JSR RAND							;GET RANDOM VALUE BETWEEN 0 AND 19.
	STA ZPADDR+12						;STORE RANDOM VALUE IN ZPADDR+12
	LDA COMP_TMPSCORE					;LOAD THE MOVE'S SCORE
	CLC
	ADC ZPADDR+12						;ADD THE RANDOM VALUE TO THE SCORE
	STA COMP_TMPSCORE					;AND STORE THE SCORE AGAIN
					
	;NOW THAT ALL THE SCORES AND PENALTIES ARE ADDED, LETS STORE THE INFORMATION IN THE COMP_INDIV_SCORES ARRAY
	LDA COMP_TMPSCORE
	STA COMP_INDIV_SCORES+6				;STORE THE UPWARDS MOVE SCORE IN COMP_INDIV_SCORES+6
	LDA ZPADDR+10						
	STA COMP_INDIV_SCORES+7				;LOAD THE UPWARDS MOVE XY POSITION IN COMP_INDIV_SCORES+7
	
	
;**************************************************************
;HERE WE NEED TO CALCULATE THE BEST MOVE OF THE 4 POSSIBLE MOVES AND STORE IT IN THE COMP_TOT_SCORES_HIGH ARRAY
COMPUTERPHASE3_1_CALC_BESTMOVE:			
	LDX #0								;LOAD X FOR THE LOOP COUNTER (AND RESET TO 0)
	STZ ZPADDR+9						;ZERO OUT ZPADDR+9, WE'LL USE IT TO STORE THE HIGHEST SCORE
COMPUTERPHASE3_1_CALC_BESTMOVE_LOOP:
	LDA COMP_INDIV_SCORES,X				;LOAD THE SCORE FROM THE COMP_INDIV_SCORES, OFFSET BY X (0,2,4,6)
	CMP ZPADDR+9						;COMPARE THE SCORE TO THE HIGEST SCORE YET
	BCC	COMPUTERPHASE3_1_CALC_BESTMOVE_LOOP_NEXT	;IF THE SCORE IS LESS THEN THE HIGHEST SCORE, THEN WE MOVE ON TO CHECK THE NEXT MOVE
	;OTHERWISE WE STORE THE SCORE AND XY POS IN ZPADDR+9 AND ZPADDR+10 AS THE BEST MOVE TO DO THUS FAR FOR THIS PIECE
	STA ZPADDR+9						;STORE STORE IN ZPADDR+9
	INX									;INCEMENT X BY ONE, SO WE CAN READ THE XY POS
	LDA COMP_INDIV_SCORES,X				;LOAD THE XY POS OF THE MOVE (1,3,5,7)
	STA ZPADDR+10						;STORE XY POS IN ZPADDR+10
	DEX									;DECREMENT X BY ONE, SO WE CAN CHECK IF THERE'S MORE MOVES TO CHECK FOR THIS PIECE
COMPUTERPHASE3_1_CALC_BESTMOVE_LOOP_NEXT:
	CPX #6								;CHECK IF LOOP COUNTER IS ALREADY AT 6 (MEANING WE CHECKED ALL FOUR MOVES)
	BEQ COMPUTERPHASE3_1_CALC_BESTMOVE_LOOP_DONE	;THEN END THE LOOPCOUNTER
	INX
	INX									;IF NOT AT 6, THEN INCREMENT X TWICE AND THEN TEST THE NEXT MOVED
	BRA COMPUTERPHASE3_1_CALC_BESTMOVE_LOOP
	
COMPUTERPHASE3_1_CALC_BESTMOVE_LOOP_DONE:	
	;THE BEST MOVE OF THE PIECE IS STORED IN ZPADDR+9 (SCORE), AND ZPADDR+10 (XY POS)
	;STORE THE NEXT SCORE AND XY POS IN THE COMPUTER TOTAL SCORES LIST	
	LDA #COMP_TOT_SCORES_HIGH			;LOAD THE HIGH BYTE OF THE COMPUTER TOTAL SCORES ARRAY
	STA ZPADDR+2						;AND STORE THE HIGH BYTE IN ZPADDR+2
	LDA ZPADDR+8						;LOAD THE PIECE COUNTER (0-39)
	ASL									;MULTIPLY THE COUNTER BY 2
	CLC
	ADC ZPADDR+8						;AND ADD THE COUNTER AGAIN, SO NOW IT'S BEEN MULTIPLIED BY 3
	STA ZPADDR+1						;STORE THE MULTIPLIED COUNTER IN ZPADDR+1, IT'LL BE OUR LOW BYTE FOR THE COMPUTER TOTAL SCORE LIST (FIRST BYTE)
	
	LDA ZPADDR+8						;RELOAD THE PIECE COUNTER (WE DON'T WANT IT MULTIPLIED BY 3 ANYMORE)
	CLC
	ADC COMP_PIECE_OFFSET				;ADD THE INCREMENT (NOTHING FOR RED PIECES, BUT ADD 40 IF PC IS PLAYING BLUE TEAM)
	STA (ZPADDR+1)						;STORE THE COUNTER+INCREMENT IN THE FIRST BYTE OF THE COMP TOTAL SCORE ARRAY (0-79)
	
	LDY ZPADDR+1						;LOAD THE LOW BYTE AGAIN, AND INCREMENT BY ONE
	INY
	STY ZPADDR+1						;AFTER INCREMENT, STORE IT AGAIN IN THE LOW BYTE, IT NOW POINTS TO THE SECOND BYTE
	LDA ZPADDR+9						;LOAD THE HIGHEST SCORE FOR THIS SPRITE (ZPADDR+9)
	STA (ZPADDR+1)						;AND STORE THE SCORE IN THE SECOND BYTE OF THE COMPUTER TOTAL SCORES LIST
	
	LDY ZPADDR+1						;LOAD THE LOW BYTE AGAIN, AND INCREMENT BY ONE
	INY
	STY ZPADDR+1						;AFTER INCREMENT, STORE IT AGAIN IN THE LOW BYTE, IT NOW POINTS TO THE THIRD BYTE
	LDA ZPADDR+10						;LOAD THE XY POSITION OF THE BEST MOVE OF THE SPRITE (ZPADDR+10)
	STA (ZPADDR+1)						;STORE THE XY POSITION IN THE THIRD BYTE OF THE COMPUTER TOTAL SCORE ARRAY.
	
	;SPRITE NUMBER, BEST SCORE AND XY POSITION FOR THIS PIECE HAVE BEEN STORE IN THE ARRAY, NOW ON TO CHECK THE NEXT PIECE!
COMPUTERPHASE3_1_FINLOOP:				;HERE WE'RE GOING TO INCREASE THE LOOP COUNTER TO LOOP THROUGH THE REST OF THE 40 PIECES
	LDX ZPADDR+8
	CPX #39								;CHECK IF WE ALREADY LOOPED THROUGH ALL 40 PIECES
	BEQ COMPUTERPHASE3_1_ENDLOOP		;IF WE HAVE CHECKED ALL 40 ALREADY, THEN WE HAVE FILLED THE WHOLE COMPUTER TOTAL SCORE ARRAY
	INX
	STX ZPADDR+8						;LOAD THE SPRITE COUNTER LOOP, INCREMENT BY 1 AND STORE AGAIN
	
	;CLEAR THE 8 BYTES OF THE COMP_INDIV_SCORES ARRAY FOR THE NEXT GAMEPIECE
	LDX #0								;LOAD 0 IN X REGISTER (LOOP COUNTER)
COMPUTERPHASE3_1_1L:
	STZ COMP_INDIV_SCORES,X				;STORE 0 IN THE COMP_INDIV_SCORES LOCATION, OFFSET BY X
	CPX #7								;CHECK IF WE ALREADY CLEARED 8 BYTES
	BEQ COMPUTERPHASE3_1_1L_DONE		;IF WE DID, EXIT THE LOOP
	INX
	BRA COMPUTERPHASE3_1_1L				;INCREMENT X BY 1 AND LOOP BACK
COMPUTERPHASE3_1_1L_DONE:
	JMP COMPUTERPHASE3_1_LOOP			;JUMP BACK TO THE BEGINNING OF THE LOOP

COMPUTERPHASE3_1_ENDLOOP:				;HERE WE'RE DONE CHECKING AND FILLING THE WHOLE COMPUTER TOTAL SCORE ARRAY
;NOW WE HAVE CALCULATED THE MOVES FOR EACH PIECE AND FILLED THE COMPUTER TOTAL SCORE ARRAY
;WE HAVE TO LOOP THROUGH THE 2ND BYTE OF THE ARRAY, FIND THE HIGHEST SCORE, SAVE THE XY POS AND SPRITE NUMBER AND THEN MOVE THE PIECE!
	LDX #0								;RESET X TO ZERO, IT WILL BE OUR LOOP COUNTE
	LDA #COMP_TOT_SCORES_HIGH			;LOAD THE HIGH BYTE OF THE COMPUTER TOTAL SCORES ARRAY
	STA ZPADDR+2						;AND STORE THE HIGH BYTE IN ZPADDR+2
	LDA #1								;LOAD 1 IN TO A ARRAY (SO LOW BYTE WILL POINT TO 2ND BYTE)
	STA ZPADDR+1						;STORE LOW BYTE IN ZPADDR+1
	STZ ZPADDR+8						
	STZ ZPADDR+9
	STZ ZPADDR+10						;ZERO OUT ZPADDR+8, +9 AND +10, WE'LL USE THOSE AS THE HIGHEST SCORE, PIECE NUMBER AND XY POS
COMPUTERPHASE3_6_L:
	LDA (ZPADDR+1)						;LOAD THE 2ND BYTE IN THE COMPUTER TOTAL SCORE ARRAY
	CMP ZPADDR+8						;COMPARE THE SCORE TO THE HIGHEST SCORE YET IN ZPADDR+8
	BCC COMPUTERPHASE3_6_L_NEXT			;IF IT'S LESS THEN THE HIGHES SCORE, TRY THE NEXT SCORE
	;IF THE SCORE IS THE SAME OR HIGHER, THEN RECORD THE SCORE, SPRITE NUMBER AND XY POS IN ZPADDR+8,9 AND 10
	STA ZPADDR+8						;STORE THE HIGHEST SCORE IN ZPADDR+8
	LDY ZPADDR+1						;LOAD THE LOW BYTE IN Y
	DEY
	STY ZPADDR+1						;DECREMENT THE LOW BYTE BY ONE AND STORE AGAIN
	LDA (ZPADDR+1)						;LOAD THE 1ST BYTE FROM THE COMPUTER TOTAL SCORE ARRAY (= SPRITE NUMBER)
	STA ZPADDR+9						;STORE THE SPRITE NUMBER IN ZPADDR+9
	INY
	INY									;INCREMENT Y TWICE, SO IT NOW POINTS TO THE 3RD BYTE OF THE COMPUTER TOTAL SCORE ARRAY
	STY ZPADDR+1						;STORE IN ZPADDR+1 (LOW BYTE)
	LDA (ZPADDR+1)						;LOAD THE THIRD BYTE (XY POSITION)
	STA ZPADDR+10						;STORE XY POS IN ZPADDR+10
	DEY
	STY ZPADDR+1						;DECREMENT Y BY ONE, AND STORING IN ZPADDR+1, RESTORING THE LOW BYTE TO THE 2ND BYTE OF THE COMPUTER TOTAL SCORE ARRAY
COMPUTERPHASE3_6_L_NEXT:	
	CPX #39								;CHECK IF WE HAVE ALREADY CHECKED ALL 39 PIECES
	BEQ COMPUTERPHASE3_6_L_END			;IF WE HAVE, END THE LOOPCOUNTER
	;IF NOT, THEN INCREMENT THE LOOP COUNTER, SET THE LOW BYTE TO THE NEXT SCORE AND TRY AGAIN
	INX									;INCREMENT THE LOOP COUNTER
	LDY ZPADDR+1						;LOAD THE LOW BYTE IN THE COMPUTER TOTAL SCORE ARRAY (2ND BYTE)
	INY
	INY
	INY									;INCREMENT Y THREE TIMES, SO IT POINTS TO THE 2ND BYTE OF THE NEXT SPRITE IN THE COMPUTER TOTAL SCORE ARRAY
	STY ZPADDR+1						;AND STORE BACK IN THE ZPADDR+1 (LOW BYTE)
	BRA COMPUTERPHASE3_6_L				;LOOP BACK TO TEST THE NEXT SCORE IN THE COMPUTER TOTAL SCORE ARRAY

COMPUTERPHASE3_6_L_END:	
	;WE NOW HAVE THE BEST MOVE IN ZPADDR+8 (SCORE), ZPADDR+9 (SPRITE NUMBER), ZPADDR+10 (XY POSITION)
	;SO PERFORM THAT MOVE BACK IN THE MAIN GAME LOOP
	RTS									;ALL DONE, RETURN TO THE MAIN GAME LOOP
	
;----------------------------------------------
;FUNCTION - MOVE COMPUTER PIECE, WHICH WILL ACTUALLY MOVE THE PIECE IF IT'S NOT A ATTACKING MOVE
;----------------------------------------------	
MOVECOMPPIECE:
	;WE NOW HAVE THE BEST MOVE IN ZPADDR+8 (SCORE), ZPADDR+9 (SPRITE NUMBER), ZPADDR+10 (XY POSITION)
	LDA ZPADDR+10						;LOAD THE MOVE THE COMPUTER WANTS TO MAKE
	AND #%00001111						;APPLY A BITMASK TO THE CURSORACTION2, SO ONLY THE Y POSITION REMAINS
	TAY									;TRANSFER THE Y POSITION TO THE Y REGISTER
	LDA ZPADDR+10						;RELOAD THE CURSORACTION2 POSITION
	AND #%11110000						;APPLY A BITMASK TO ONLY THE X POSITION REMAINS
	LSR									;BIT SHIFT TO THE RIGHT (0XXXX000)
	LSR									;BIT SHIFT TO THE RIGHT (00XXXX00)
	LSR									;BIT SHIFT TO THE RIGHT (000XXXX0)
	LSR									;BIT SHIFT TO THE RIGHT (0000XXXX)
	TAX									;TRANSFER THE X POSITION TO THE X REGISTER
	LDA ZPADDR+9						;LOAD THE SPRITE NUMBER IN A
	JSR MOVEPIECE						;MOVE THE GAME PIECE TO THE NEW LOCATION (VARIABLES ONLY)
	JSR SHOWPIECE						;AND SHOW THE PIECE AT IT'S NEW LOCATION
	
	RTS									;ALL DONE, RETURN TO THE MAIN GAME LOOP