;----------------------------------------------
;FUNCTION - CHECK PLAYER ATTACK, CHECKS IF THE PLAYER'S MOVE RESULTS IN A ATTACK INSTEAD OF JUST A MOVE.
;----------------------------------------------
CHKPLAYERATTACK:
	;HERE WE NEED TO CHECK IF THERE'S ANY SPRITE IN CURSORACTION2, AND IF SO, IF IT'S A COMPUTER PIECE
	LDA CURSORACTION2				;LOAD CURSORACTION2'S POSITION
	AND #%00001111					;APPLY A BITMASK TO THE CURSORACTION2, SO ONLY THE Y POSITION REMAINS
	TAY								;TRANSFER THE Y POSITION TO THE Y REGISTER
	LDA CURSORACTION2				;RELOAD THE CURSORACTION2 POSITION
	AND #%11110000					;APPLY A BITMASK TO ONLY THE X POSITION REMAINS
	LSR								;BIT SHIFT TO THE RIGHT (0XXXX000)
	LSR								;BIT SHIFT TO THE RIGHT (00XXXX00)
	LSR								;BIT SHIFT TO THE RIGHT (000XXXX0)
	LSR								;BIT SHIFT TO THE RIGHT (0000XXXX)
	TAX								;TRANSFER THE X POSITION TO THE X REGISTER
	JSR GETSPRITENUMBER				;NOW TRY TO FIND A SPRITE NUMBER BASED ON THE X AND Y POSITION.
	CMP #255						;CHECK IF THE RETURNED SPRITE NUMBER IS 255 (AKA, NOT FOUND)
	BEQ CHKPLAYERATTACK_NOATTACK	;IF NO SPRITE IS FOUND, JUMP TO CHKPLAYERATTACK_NOATTACK
	
	;IF A SPRITE IS FOUND, WE NEED TO CHECK WHICH TEAM IT BELONGS TO, AND IF THAT TEAM IS A COMPUTER SPRITE
	STA ZPADDR+10					;STORE THE SPRITE NUMBER IN ZPADDR+10 FOR NOW
	LDA VAR_TEAM					;GET WHICH TEAM THE PLAYER IS PLAYING AT (0=RED, 1=BLUE)
	CMP #0							;CHECK IF THE PLAYER IS PLAYINT WITH THE RED PIECES
	BEQ CHKPLAYERATTACK_R			;THEN GO CHECK IF THE RETURNED PIECE IS A BLUE PIECE (COMPUTER PIECE)
	;OTHERWISE THE PLAYER IS PLAYING THE BLUE PIECES. WE NEED TO CHECK IF THE SPRITE FOUND (NOW IN ZPADDR+10) IS ONE OF THE RED PIECES (SPRITE 0 TO 39)
	LDA ZPADDR+10
	CMP #40							;CHECK IF THE SPRITE NUMBER IS 40
	BCC	CHKPLAYERATTACK_ATTACK		;IF THE SPRITE NUMBER IN ZPADDR+10 IS LESS THEN 40, THEN IT'S A RED PIECE, THUS A COMPUTERS PIECE!
	BRA CHKPLAYERATTACK_NOATTACK	;OTHERWISE IT A BLUE PIECE, AND THAT MEANS IT'S NOT A ATTACKING MOVE
	
CHKPLAYERATTACK_R:
	;THE PLAYER IS PLAYING THE RED PIECES. WE NEED TO CHECK IF THE SPRITE FOUND (NOW IN ZPADDR+10) IS ONE OF THE BLUE PIECES (SPRITE 40 TO 79)
	LDA ZPADDR+10
	CMP #40							;CHECK IF THE SPRITE NUMBER IS 40
	BCS	CHKPLAYERATTACK_ATTACK		;IF THE SPRITE NUMBER IN ZPADDR+10 IS 40 OR HIGHER THEN IT'S A BLUE PIECE, THUS A COMPUTERS PIECE!
	BRA CHKPLAYERATTACK_NOATTACK	;OTHERWISE IT A RED PIECE, AND THAT MEANS IT'S NOT A ATTACKING MOVE
	
CHKPLAYERATTACK_ATTACK:				;A COMPUTER PIECE HAS BEEN FOUND AT CURSORACTION2!
	LDA #1
	RTS								;RETURN WITH A 1 IN THE ACCUMULATOR, TO SAY THAT THERE'S A ATTACKING MOVE IN CURSORACTION2!
	
CHKPLAYERATTACK_NOATTACK:			;NO COMPUTER SPRITE FOUND AT CURSORACTION2
	LDA #0
	RTS								;RETURN WITH A 0 IN THE ACCUMULATOR, TO SAY THAT THERE'S NO ATTACKING MOVE IN CURSORACTION2
	
;----------------------------------------------
;FUNCTION - CHECK COMPUTER ATTACK, CHECKS IF THE COMPUTERS'S MOVE RESULTS IN A ATTACK INSTEAD OF JUST A MOVE.
;----------------------------------------------
CHKCOMPATTACK:
	;HERE WE NEED TO CHECK IF THERE'S ANY SPRITE IN CURSORACTION2, AND IF SO, IF IT'S A COMPUTER PIECE
	LDA ZPADDR+10					;LOAD THE MOVE THE COMPUTER WANTS TO MAKE
	AND #%00001111					;APPLY A BITMASK TO THE CURSORACTION2, SO ONLY THE Y POSITION REMAINS
	TAY								;TRANSFER THE Y POSITION TO THE Y REGISTER
	LDA ZPADDR+10					;RELOAD THE CURSORACTION2 POSITION
	AND #%11110000					;APPLY A BITMASK TO ONLY THE X POSITION REMAINS
	LSR								;BIT SHIFT TO THE RIGHT (0XXXX000)
	LSR								;BIT SHIFT TO THE RIGHT (00XXXX00)
	LSR								;BIT SHIFT TO THE RIGHT (000XXXX0)
	LSR								;BIT SHIFT TO THE RIGHT (0000XXXX)
	TAX								;TRANSFER THE X POSITION TO THE X REGISTER
	JSR GETSPRITENUMBER				;NOW TRY TO FIND A SPRITE NUMBER BASED ON THE X AND Y POSITION.
	CMP #255						;CHECK IF THE RETURNED SPRITE NUMBER IS 255 (AKA, NOT FOUND)
	BEQ CHKCOMPATTACK_NOATTACK		;IF NO SPRITE IS FOUND, JUMP TO CHKCOMPATTACK_NOATTACK
	
	;IF A SPRITE IS FOUND, WE NEED TO CHECK WHICH TEAM IT BELONGS TO, AND IF THAT TEAM IS A PLAYER SPRITE
	STA ZPADDR+11					;STORE THE SPRITE NUMBER IN ZPADDR+11 FOR NOW
	LDA VAR_TEAM					;GET WHICH TEAM THE COMPUTER IS PLAYING AT (0=BLUE, 1=RED)
	CMP #1							;CHECK IF THE COMPUTER IS PLAYING WITH THE RED PIECES
	BEQ CHKCOMPATTACK_R				;THEN GO CHECK IF THE RETURNED PIECE IS A BLUE PIECE (PLAYER PIECE)
	;OTHERWISE THE PLAYER IS PLAYING THE BLUE PIECES. WE NEED TO CHECK IF THE SPRITE FOUND (NOW IN ZPADDR+10) IS ONE OF THE RED PIECES (SPRITE 0 TO 39)
	LDA ZPADDR+11
	CMP #40							;CHECK IF THE SPRITE NUMBER IS 40
	BCC	CHKCOMPATTACK_ATTACK		;IF THE SPRITE NUMBER IN ZPADDR+11 IS LESS THEN 40, THEN IT'S A RED PIECE, THUS A PLAYER PIECE!
	BRA CHKCOMPATTACK_NOATTACK		;OTHERWISE IT A BLUE PIECE, AND THAT MEANS IT'S NOT A ATTACKING MOVE
	
CHKCOMPATTACK_R:
	;THE COMPUTER IS PLAYING THE RED PIECES. WE NEED TO CHECK IF THE SPRITE FOUND (NOW IN ZPADDR+11) IS ONE OF THE BLUE PIECES (SPRITE 40 TO 79)
	LDA ZPADDR+11
	CMP #40							;CHECK IF THE SPRITE NUMBER IS 40
	BCS	CHKCOMPATTACK_ATTACK		;IF THE SPRITE NUMBER IN ZPADDR+10 IS 40 OR HIGHER THEN IT'S A BLUE PIECE, THUS A PLAYER PIECE!
	BRA CHKCOMPATTACK_NOATTACK		;OTHERWISE IT A RED PIECE, AND THAT MEANS IT'S NOT A ATTACKING MOVE
	
CHKCOMPATTACK_ATTACK:				;A PLAYER PIECE HAS BEEN FOUND AT THE INTENDED COMPUTER MOVE (ZPADDR+10)!
	LDA #1
	RTS								;RETURN WITH A 1 IN THE ACCUMULATOR, TO SAY THAT THERE'S A ATTACKING MOVE
	
CHKCOMPATTACK_NOATTACK:				;NO PLAYER SPRITE FOUND AT THE INTENDED COMPUTER MOVE
	LDA #0
	RTS								;RETURN WITH A 0 IN THE ACCUMULATOR, TO SAY THAT THERE'S NO ATTACKING MOVE
	
;----------------------------------------------
;FUNCTION - HANDLE ATTACK. HERE WE'RE GOING TO PROCESS THE PIECE IN CURSORACTION1 ATTACKING THE PIECE IN CURSORACTION2
;----------------------------------------------
HANDLEATTACK:
	;THESE RULES HAVE TO BE BUILD INTO PHASE 4. ATTACKING PIECE IS A, DEFENDING PIECE IS B:
	;1) IF B IS A FLAG, THEN THE A TEAM WINS THE GAME
	;2) IF B IS A BOMB, THEN A IS KILLED EXCEPT WHEN A IS A MINER, THEN B IS KILLED.
	;3) IF A IS THE SAME SPRITE TYPE AS B (EQUAL PIECES), THEN BOTH PIECES ARE REMOVED FROM THE BOARD.
	;4) IF B IS A MARSHALL, THEN A IS KILLED, EXCEPT WHEN A IS A SPY, THEN B IS KILLED.
	;5) WHEN A'S PIECE TYPE > B'S PIECE TYPE THEN B IS KILLED. OTHERWISE A IS KILLED. (HIGHER RANK KILLS LOWER RANK)
	
	;FIRST WE NEED TO GET THE SPRITE NUMBERS, X POSITION, Y POSITION AND SPRITE TYPE FOR BOTH CURSORACTION1 AND CURSORACTION2
	LDA CURSORACTION1				;LOAD THE XY POSITION FOR THE ATTACKING PIECE (A)
	AND #%00001111					;APPLY BITMASK TO ONLY GET Y POSITION
	TAY								;STORE Y POSITION IN Y REGISTER
	LDA CURSORACTION1				;RELOAD CURSORACTION1
	AND #%11110000					;NOW APPLY BITMASK TO FILTER OUT THE X POSITION
	LSR								;BITSHIFT TO THE RIGHT (0XXXX000)
	LSR								;BITSHIFT TO THE RIGHT (00XXXX00)
	LSR								;BITSHIFT TO THE RIGHT (000XXXX0)
	LSR								;BITSHIFT TO THE RIGHT (0000XXXX)
	TAX								;STORE X POSITION IN X REGISTER
	JSR GETSPRITENUMBER				;GET THE SPRITE NUMBER BELONGING TO THIS XY POSITION
	JSR GETSPRITEDATA				;GET THE SPRITE DATA BELONGING TO THIS XY POSITION
	;NOW WE'RE GOING TO COPY SOME OF THE SPRITE DATA FROM ZPADDR-ZPADDR+7 TO ZPADDR+9 AND FURTHER.
	;WE NEED TO COPY THE SPRITE NUMBER (ZPADDR), X POS (ZPADDR+2), Y POS (ZPADDR+3) AND SPRITE TYPE (ZPADDR+4)
	LDA ZPADDR
	STA ZPADDR+9					;COPY SPRITE NUMBER INTO ZPADDR+9
	LDA ZPADDR+2
	STA ZPADDR+10					;COPY X POSITION INTO ZPADDR+10
	LDA ZPADDR+3
	STA ZPADDR+11					;COPY Y POSITION INTO ZPADDR+11
	LDA ZPADDR+4
	STA ZPADDR+12					;COPY SPRITE TYPE INTO ZPADDR+12
	
	;NOW TO GET THE SPRITE NUMBER, THEN DATA FOR CURSORACTION2
	LDA CURSORACTION2
	AND #%00001111					;APPLY BITMASK TO ONLY GET Y POSITION
	TAY								;STORE Y POSITION IN Y REGISTER
	LDA CURSORACTION2				;RELOAD CURSORACTION1
	AND #%11110000					;NOW APPLY BITMASK TO FILTER OUT THE X POSITION
	LSR								;BITSHIFT TO THE RIGHT (0XXXX000)
	LSR								;BITSHIFT TO THE RIGHT (00XXXX00)
	LSR								;BITSHIFT TO THE RIGHT (000XXXX0)
	LSR								;BITSHIFT TO THE RIGHT (0000XXXX)
	TAX								;STORE X POSITION IN X REGISTER
	JSR GETSPRITENUMBER				;GET SPRITE NUMBER AT XY POSITION OF CURSORACTION2
	JSR GETSPRITEDATA				;GET THE SPRITE DATA FOR THIS SPRITE/PIECE
	;NOW WE'RE GOING TO COPY SOME OF THE SPRITE DATA FROM ZPADDR-ZPADDR+7 TO ZPADDR+9 AND FURTHER.
	;WE NEED TO COPY THE SPRITE NUMBER (ZPADDR), X POS (ZPADDR+2), Y POS (ZPADDR+3) AND SPRITE TYPE (ZPADDR+4)
	LDA ZPADDR
	STA ZPADDR+13					;COPY SPRITE NUMBER INTO ZPADDR+9
	LDA ZPADDR+2
	STA ZPADDR+14					;COPY X POSITION INTO ZPADDR+10
	LDA ZPADDR+3
	STA ZPADDR+15					;COPY Y POSITION INTO ZPADDR+11
	LDA ZPADDR+4
	STA ZPADDR+16					;COPY SPRITE TYPE INTO ZPADDR+12
	
	;BEFORE WE DO ANYTHING, LETS SHOW THE COMPUTER'S PIECE'S FRONT, REGARDLESS IF IT'S THE ATTACKER OR DEFENDER
	LDX #1
	STX VAR_ATTACK					;STORE 1 IN VAR_ATTACK TO SHOW THE PIECES FRONT! (INSTEAD OF HIDING THE COMPUTER'S PIECE)
	LDA ZPADDR+9					;LOAD THE SPRITE NUMBER FOR A (ATTACKING) PIECE
	JSR SHOWPIECE					;SHOW THE SPRITE'S FRONT (IF IT'S A PLAYERS PIECE NOTHING WILL HAPPEN)
	LDA ZPADDR+13					;LOAD THE SPRITE NUMBER FOR B (DEFENDING) PIECE
	JSR SHOWPIECE					;SHOW THE SPRITE'S FRONT (IF IT'S A PLAYERS PIECE NOTHING WILL HAPPEN)
	STZ VAR_ATTACK					;AND RESET THE VAR_ATTACK VARIABLE TO SHOW THE NEXT SPRITES AS NORMAL (HIDING THE COMPUTER'S PIECES)
	
	;NOW THAT WE HAVE THE DATA LETS GO THROUGH THE 6 ATTACK CHECKS AND SEE WHICH PIECE GETS TAKEN OF THE FIELD
	; A = ATTACKING PIECE, B = DEFENDING PIECE
HANDLEATTACK_CHECK1:
;*** CHECK 1) IF B IS A FLAG, THEN THE A TEAM WINS THE GAME
	LDA ZPADDR+16					;LOAD B'S SPRITE NUMBER
	CMP #1							;CHECK IF IT'S A FLAG
	BNE HANDLEATTACK_CHECK2			;IF IT'S NOT A BOMB, GOTO CHECK 2
	;IF IF IS A BOMB THEN THE ATTACKING PLAYER HAS WON! WE NEED TO FIND OUT WHO THE ATTACKING PLAYER IS THOUGH....
	LDA ZPADDR+9					;LOAD THE SPRITE NUMBER FOR THE ATTACKING PIECE
	CMP #40							;CHECK IF THE SPRITE NUMBER IS 40
	BCC RED_WON						;IF IT'S LESS THEN 40, THEN A RED PIECE HAS ATTACKED (AND WON)
	;OTHERWISE THE BLUE TEAM WON, LETS FIND OUT IF THE PLAYER IS THE BLUE TEAM SO WE CAN CONGRATULATE HIM/HER
	LDA VAR_TEAM					;LOAD THE PLAYER'S TEAM (0=RED, 1=BLUE)
	CMP #1							;CHECK IF THE PLAYER IS PLAYING THE BLUE PIECES
	BNE COMPUTER_WON				;IF THE PLAYER ISN'T PLAYING BLUE, THEN HE LOST... GO SHOW MESSAGE ON THE SCREEN
	BEQ PLAYER_WON					;IF THE PLAYER IS, THEN HE/SHE WON!
	
RED_WON:
	;OTHERWISE THE RED TEAM WON, LETS FIND OUT IF THE PLAYER IS THE RED TEAM SO WE CAN CONGRATULATE HIM/HER
	LDA VAR_TEAM					;LOAD THE PLAYER'S TEAM (0=RED, 1=BLUE)
	CMP #0							;CHECK IF THE PLAYER IS PLAYING THE RED PIECES
	BNE COMPUTER_WON				;IF THE PLAYER ISN'T PLAYING RED, THEN HE LOST... GO SHOW MESSAGE ON THE SCREEN
	BEQ PLAYER_WON					;IF THE PLAYER IS, THEN HE/SHE WON!
	
COMPUTER_WON:
	;SHAME, THE COMPUTER WON.... SHOW A MESSAGE ON THE SCREEN
	LDA #<YOULOST					;SHOW TEXT ON SCREEN
	STA z_L
	LDA #>YOULOST
	STA z_H
	JSR PrintString
	JSR CINPUT						;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	JMP PLAYAGAIN					;JUMP TO ASK THE PLAYER IF THEY WANT TO PLAY AGAIN

PLAYER_WON:
	;HURRAY! THE PLAYER WON.... SHOW A MESSAGE ON THE SCREEN
	LDA #<YOUWON					;SHOW TEXT ON SCREEN
	STA z_L
	LDA #>YOUWON
	STA z_H
	JSR PrintString
	JSR CINPUT						;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	JMP PLAYAGAIN					;JUMP TO ASK THE PLAYER IF THEY WANT TO PLAY AGAIN

HANDLEATTACK_CHECK2:
;*** CHECK 2) IF B IS A BOMB, THEN A IS KILLED EXCEPT WHEN A IS A MINER, THEN B IS KILLED.
	LDA ZPADDR+16					;GET B'S PIECE/SPRITE TYPE
	CMP #0							;CHECK IF IT'S A BOMB
	BNE HANDLEATTACK_CHECK3_JMP		;IF IT'S NOT A BOMB, GO TO CHECK 3
	;IF IT IS A BOMB, WE NEED TO CHECK IF THE ATTACKING PIECE IS A MINER, IF NOT, THEN A DIES, IF A IS A MINER THEN THE BOMB (B) DIES
	LDA ZPADDR+12					;LOAD A'S SPRITE TYPE
	CMP #4							;CHECK IF IT'S A MINER
	BNE PIECEA_DIES					;IF A IS NOT A MINER, THEN THE ATTACKING PIECE DIES
	BEQ PIECEB_DIES					;IF THE ATTACKER IS A MINER, THEN THE BOMB DIES!

;HERE WE'RE GOING TO HANDLE PIECE_B (DEFENDER) BEING KILLED, SPRITE DATA CHANGED AND THE PIECE MOVED OFF THE SCREEN
PIECEB_DIES:	
	;QUICKLY CHECK IF B IS ONE OF THE PLAYERS PIECES
	LDA VAR_TEAM
	CMP #0							;CHECK IF THE PLAYER IS PLAYING THE RED PIECES
	BNE PIECEB_DIES_B				;IF NOT, THEN THE PLAYER IS PLAYING BLUE
	LDA ZPADDR+13					;LOAD B'S SPRITE NUMBER
	CMP #40							;ANC COMPARE IT TO 40
	BCC PIECEB_DIES_CWIN			;IF IT'S LESS THEN 40, THEN B IS ONE OF THE PLAYERS PIECES
	BCS PIECEB_DIES_PWIN			;IF IT'S 40 OR MORE, THEN B IS ONE OF THE COMPUTERS PIECES
PIECEB_DIES_B						;IF THE PLAYER IS PLAYING FOR THE BLUE TEAM
	LDA ZPADDR+13					;LOAD B'S SPRITE NUMBER
	CMP #40							;ANC COMPARE IT TO 40
	BCC PIECEB_DIES_PWIN			;IF IT'S LESS THEN 40, THEN B IS ONE OF THE PLAYERS PIECES
	BCS PIECEB_DIES_CWIN			;IF IT'S 40 OR MORE, THEN B IS ONE OF THE COMPUTERS PIECES

PIECEB_DIES_CWIN
	LDA #<YOUPKILLED				;SHOW TEXT ON SCREEN
	STA z_L
	LDA #>YOUPKILLED
	STA z_H
	JSR PrintString
	JSR CINPUT						;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	BRA PIECEB_DIES_DONE
PIECEB_DIES_PWIN
	LDA #<COMPPKILLED				;SHOW TEXT ON SCREEN
	STA z_L
	LDA #>COMPPKILLED
	STA z_H
	JSR PrintString
	JSR CINPUT						;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	BRA PIECEB_DIES_DONE
	
PIECEB_DIES_DONE
	;HERE WE'RE ACTUALLY DOING THE KILLING OF THE PIECE, DISABLING SPRITES AND MOVING OFF SCREEN
	LDA ZPADDR+9					;LOAD THE SPRITE NUMBER FOR A (ATTACKING) PIECE
	JSR SHOWPIECE					;SHOW THE SPRITE AS NORMAL (HIDING THE COMPUTERS SPRITE, IF A IS A COMPUTER PIECE)
	LDA ZPADDR+13					;LOAD THE SPRITE NUMBER FOR B (DEFENDING) PIECE
	JSR SHOWPIECE					;SHOW THE SPRITE AS NORMAL (HIDING THE COMPUTERS SPRITE, IF B IS A COMPUTER PIECE)
	
	LDA ZPADDR+13					;LOAD THE DEFENDER (B)'S PIECE/SPRITE NUMBER
	JSR KILLSPRITE					;KILL THE PIECE (AND MOVE OFF SCREEN)
	
	JSR MOVEPOS1TOPOS2				;MOVE THE PIECE FROM THE SOURCE TO DESTINATION LOCATION
	RTS								;PHASE 4 ATTACK CHECK DONE, RETURN TO PREVIOUS CODE!

HANDLEATTACK_CHECK3_JMP				;TEMP JUMP POINT, THE BRANCH DESTINATION IS OUT OF REACH
	BRA HANDLEATTACK_CHECK3

;HERE WE'RE GOING TO HANDLE PIECE_A (ATTACKER) BEING KILLED, SPRITE DATA CHANGED AND THE PIECE MOVED OFF THE SCREEN	
PIECEA_DIES:
	;QUICKLY CHECK IF B IS ONE OF THE PLAYERS PIECES
	LDA VAR_TEAM
	CMP #0							;CHECK IF THE PLAYER IS PLAYING THE RED PIECES
	BNE PIECEA_DIES_B				;IF NOT, THEN THE PLAYER IS PLAYING BLUE
	LDA ZPADDR+9					;LOAD A'S SPRITE NUMBER
	CMP #40							;ANC COMPARE IT TO 40
	BCC PIECEA_DIES_CWIN			;IF IT'S LESS THEN 40, THEN B IS ONE OF THE PLAYERS PIECES
	BCS PIECEA_DIES_PWIN			;IF IT'S 40 OR MORE, THEN B IS ONE OF THE COMPUTERS PIECES
PIECEA_DIES_B						;IF THE PLAYER IS PLAYING FOR THE BLUE TEAM
	LDA ZPADDR+9					;LOAD A'S SPRITE NUMBER
	CMP #40							;ANC COMPARE IT TO 40
	BCC PIECEA_DIES_PWIN			;IF IT'S LESS THEN 40, THEN B IS ONE OF THE PLAYERS PIECES
	BCS PIECEA_DIES_CWIN			;IF IT'S 40 OR MORE, THEN B IS ONE OF THE COMPUTERS PIECES

PIECEA_DIES_CWIN
	LDA #<YOUPKILLED				;SHOW TEXT ON SCREEN
	STA z_L
	LDA #>YOUPKILLED
	STA z_H
	JSR PrintString
	JSR CINPUT						;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	BRA PIECEA_DIES_DONE
PIECEA_DIES_PWIN
	LDA #<COMPPKILLED				;SHOW TEXT ON SCREEN
	STA z_L
	LDA #>COMPPKILLED
	STA z_H
	JSR PrintString
	JSR CINPUT						;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	BRA PIECEA_DIES_DONE
	
PIECEA_DIES_DONE	
	;HERE WE'RE ACTUALLY DOING THE KILLING OF THE PIECE, DISABLING SPRITES AND MOVING OFF SCREEN
	LDA ZPADDR+9					;LOAD THE SPRITE NUMBER FOR A (ATTACKING) PIECE
	JSR SHOWPIECE					;SHOW THE SPRITE AS NORMAL (HIDING THE COMPUTERS SPRITE, IF A IS A COMPUTER PIECE)
	LDA ZPADDR+13					;LOAD THE SPRITE NUMBER FOR B (DEFENDING) PIECE
	JSR SHOWPIECE					;SHOW THE SPRITE AS NORMAL (HIDING THE COMPUTERS SPRITE, IF B IS A COMPUTER PIECE)
	LDA ZPADDR+9					;LOAD THE ATTACKER (A)'S PIECE/SPRITE NUMBER
	JSR KILLSPRITE					;KILL THE PIECE (AND MOVE OFF SCREEN)
	
	RTS								;PHASE 4 ATTACK CHECK DONE, RETURN TO PREVIOUS CODE!
	
PIECEB_DIES_JMP						;TEMP JUMP POINT, THE BRANCH DESTINATION IS OUT OF REACH
	JMP PIECEB_DIES
PIECEA_DIES_JMP						;TEMP JUMP POINT, THE BRANCH DESTINATION IS OUT OF REACH
	JMP PIECEA_DIES
	
HANDLEATTACK_CHECK3:
;*** CHECK 3) IF A IS THE SAME SPRITE TYPE AS B (EQUAL PIECES), THEN BOTH PIECES ARE REMOVED FROM THE BOARD.
	LDA ZPADDR+16					;GET B'S PIECE/SPRITE TYPE
	CMP ZPADDR+12					;COMPARE TO A'S PIECE/SPRITE TYPE
	BNE HANDLEATTACK_CHECK4			;IF IT'S NOT THE SAME, THEN GO TO CHECK 4
	
	;IF THEY ARE THE SAME, THEN BOTH PIECES HAVE TO BE KILLED AND MOVED OFF THE SCREEN!
	LDA #<BOTHPKILLED				;SHOW TEXT ON SCREEN THAT BOTH PIECES GOT KILLED
	STA z_L
	LDA #>BOTHPKILLED
	STA z_H
	JSR PrintString
	JSR CINPUT						;WAIT FOR PLAYER TO HIT RETURN (WE WONT USE IT)
	
	LDA ZPADDR+13					;LOAD B'S SPRITE NUMBER INTO A
	JSR KILLSPRITE					;KILL THE PIECE (AND MOVE OFF SCREEN)
	LDA ZPADDR+9					;LOAD A'S SPRITE NUMBER INTO A
	JSR KILLSPRITE					;KILL THE PIECE (AND MOVE OFF SCREEN)
	RTS								;PHASE 4 ATTACK CHECK DONE, RETURN TO PREVIOUS CODE!

HANDLEATTACK_CHECK4:
;*** CHECK 4) IF B IS A MARSHALL, THEN A IS KILLED, EXCEPT WHEN A IS A SPY, THEN B IS KILLED.
	LDA ZPADDR+16					;GET THE DEFENDERS TYPE
	CMP #11							;CHECK IF B IS THE MARSHALL
	BEQ HANDLEATTACK_CHECK4_SPY		;NOW CHECK FOR A BEING A SPY
	BNE HANDLEATTACK_CHECK5			;IF THE DEFENDING PIECE IS NOT A MARSHALL, MOVE ON TO CHECK 5

HANDLEATTACK_CHECK4_SPY:
	LDA ZPADDR+12					;LOAD A'S TYPE
	CMP #2							;CHECK IF A (ATTACKER) IS A SPY
	BNE PIECEA_DIES_JMP				;IF THE ATTACKER IS NOT A SPY, THEN KILL THE ATTACKER!
	BEQ PIECEB_DIES_JMP				;IF A IS A SPY, THEN KILL THE MARSHALL!
	
HANDLEATTACK_CHECK5:
;*** CHECK 5) WHEN A'S PIECE TYPE > B'S PIECE TYPE THEN B IS KILLED. OTHERWISE A IS KILLED. (HIGHER RANK KILLS LOWER RANK)
	LDA ZPADDR+12					;LOAD THE ATTACKERS (A) TYPE
	CMP ZPADDR+16					;COMPARE IT TO THE DEFENDER'S TYPE (B)
	BCC PIECEA_DIES_JMP				;IF THE TYPE NUMBER OF A IS LESS THEN B, THEN A DIES
	BCS PIECEB_DIES_JMP				;IF THE TYPE NUMBER OF A IS MORE THEN (OR EQUAL TO) B, THEN B DIES

	
;----------------------------------------------
;FUNCTION - PLAY AGAIN, HERE WE ASK THE PLAYER IF THEY WANT TO PLAY AGAIN, IF SO WE NEED TO RESET EVERYTHING!
;----------------------------------------------
PLAYAGAIN:
	LDA #<PLAYAGAINT					;ASK THE PLAYER IF THEY WANT TO PLAY AGAIN
	STA z_L
	LDA #>PLAYAGAINT
	STA z_H
	JSR PrintString
	JSR CINPUT						;CAPTURE USER INPUT (1 CHARACTER)
	
	LDA CHRBUF						;LOAD THE FIRST CHARACTER IN THE CHARACTER BUFFER
	CMP #$59						;CHECK IF THE FIRST CHARACTER IN THE BUFFER IS #89/$59 = Y			
	BEQ PLAYAGAIN_Y					;IF IT'S Y FOR YES
	
	;IF THE PLAYER DOESN'T WANT TO PLAY AGAIN:
	LDA #<GOODBYE					;ASK THE PLAYER IF THEY WANT TO PLAY AGAIN
	STA z_L
	LDA #>GOODBYE
	STA z_H
	JSR PrintString
	JMP *							;INF LOOP/CRASH THE GAME, NOT SURE HOW TO EXIT TO BASIC...
	
PLAYAGAIN_Y:
	;LETS CLEAR ALL THE TEXT ON THE SCREEN BY FILLING ALL THE LINES WITH EMPTY TEXT
	LDA #<EMPTY						;PRINT EMPTY TEXT IN ALL FIELDS
	STA z_L
	LDA #>EMPTY
	STA z_H
	JSR PrintString
	
	;NOW WE NEED TO TURN OFF ALL THE SPRITES FOR THE GAME PIECES (SPRITES 0-79), THE TWO CURSORS (80 AND 81), AND THE LEGEND SPRITES (82-94)
	LDA #0							;ZERO OUT A, IT'LL BE THE LOOP COUNTER
PLAYAGAIN_Y_L:
	JSR HIDEPIECE					;HIDE THE SPRITE NUMBER IN A
	CMP #94							;CHECK IF HAVE ALREADY DONE ALL THE SPRITES UP TO AND INCLUDING 94
	BEQ PLAYAGAIN_Y_L_END			;THEN END THE LOOP/CRASH
	CLC
	ADC #1							
	BRA PLAYAGAIN_Y_L				;OTHERWISE INCREMENT A BY ONE, AND RUN THE NEXT ITERATION OF THE LOOP
	
PLAYAGAIN_Y_L_END:	
	;NOW JUMP BACK TO PHASE 0 TO START EVERYTHING OVER AGAIN :-)
	; ; LDA #1
	; ; STA $5F						;DEBUG, STORE 1 IN $5F
	JMP PHASE0